import bpy

# Don't be a jerk. Leave the logo intact. I've made the entire software
# free as in freedom, all I ask is that my logo stays in the front, so I
# can attract more people to work on open source software to make the
# world a better place."""
code_relay_charstrings = {
    'blackBar.coderelay.png': {
        "commands": "-468 2508 468 vlineto",
        "initialPosition": {
            "x": 0,
            "y": 0
        },
        "endPosition": {
            "x": 208,
            "y": 0
        }
    },
    "codeRelayLogo50000.coderelay.png": {
        "commands":
        "-102 callsubr\n-70 callsubr\n-504 -12 rmoveto\n-72 callsubr\n156 hmoveto\n-54 callsubr\n-76 callsubr\n96 hmoveto\n-73 callsubr\n-720 -12 rmoveto\n-68 callsubr\n96 hmoveto\n-60 callsubr\n-48 callsubr\n-59 callsubr\n-756 -12 rmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n-62 callsubr\n-101 callsubr\n24 hmoveto\n-70 callsubr\n-53 callsubr\n84 hmoveto\n-53 callsubr\n-69 callsubr\n-101 callsubr\n48 hmoveto\n-67 callsubr\n252 hmoveto\n-101 callsubr\n24 hmoveto\n-101 callsubr\n-1152 -12 rmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n85 callsubr\n-66 callsubr\n-53 callsubr\n36 hmoveto\n-53 callsubr\n-75 callsubr\n-50 callsubr\n84 hmoveto\n-52 callsubr\n-70 callsubr\n-101 callsubr\n48 hmoveto\n-61 callsubr\n180 hmoveto\n-101 callsubr\n36 hmoveto\n-69 callsubr\n-1272 -12 rmoveto\n-76 callsubr\n-101 callsubr\n84 hmoveto\n-67 callsubr\n-51 callsubr\n36 hmoveto\n-45 callsubr\n96 hmoveto\n-47 callsubr\n-76 callsubr\n-53 callsubr\n36 hmoveto\n-53 callsubr\n-59 callsubr\n120 hmoveto\n-76 callsubr\n-101 callsubr\n12 hmoveto\n85 callsubr\n-68 callsubr\n-1296 -12 rmoveto\n-76 callsubr\n-101 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-40 callsubr\n36 hmoveto\n-45 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-43 callsubr\n36 hmoveto\n-40 callsubr\n-75 callsubr\n-53 callsubr\n-76 callsubr\n96 hmoveto\n-76 callsubr\n-51 callsubr\n-73 callsubr\n-51 callsubr\n-75 callsubr\n-1308 -12 rmoveto\n16 callsubr\n36 hmoveto\n-47 callsubr\n48 hmoveto\n-50 callsubr\n72 hmoveto\n-52 callsubr\n60 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n24 hmoveto\n-52 callsubr\n72 hmoveto\n-51 callsubr\n36 hmoveto\n-50 callsubr\n60 hmoveto\n-53 callsubr\n36 hmoveto\n-52 callsubr\n24 hmoveto\n85 callsubr\n-102 callsubr\n72 hmoveto\n-76 callsubr\n-101 callsubr\n48 hmoveto\n-75 callsubr\n-53 callsubr\n48 hmoveto\n85 callsubr\n-76 callsubr\n-1320 -12 rmoveto\n16 callsubr\n36 hmoveto\n-48 callsubr\n60 hmoveto\n-51 callsubr\n84 hmoveto\n-53 callsubr\n72 hmoveto\n-53 callsubr\n84 hmoveto\n-52 callsubr\n72 hmoveto\n-51 callsubr\n36 hmoveto\n-50 callsubr\n60 hmoveto\n-53 callsubr\n36 hmoveto\n-52 callsubr\n24 hmoveto\n85 callsubr\n-76 callsubr\n60 hmoveto\n-76 callsubr\n-101 callsubr\n48 hmoveto\n-50 callsubr\n60 hmoveto\n85 callsubr\n-102 callsubr\n-1320 -12 rmoveto\n16 callsubr\n36 hmoveto\n-48 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n24 hmoveto\n-101 callsubr\n48 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n72 hmoveto\n-52 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-52 callsubr\n36 hmoveto\n-47 callsubr\n36 hmoveto\n-53 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n85 callsubr\n-74 callsubr\n12 hmoveto\n-73 callsubr\n-101 callsubr\n36 hmoveto\n-51 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n85 callsubr\n-102 callsubr\n-1320 -12 rmoveto\n16 callsubr\n36 hmoveto\n-49 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n96 hmoveto\n-101 callsubr\n72 hmoveto\n-52 callsubr\n96 hmoveto\n-52 callsubr\n36 hmoveto\n-50 callsubr\n72 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n85 callsubr\n-68 callsubr\n-101 callsubr\n36 hmoveto\n-51 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n85 callsubr\n-1320 -12 rmoveto\n16 callsubr\n36 hmoveto\n-49 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-101 callsubr\n96 hmoveto\n-101 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n96 hmoveto\n-52 callsubr\n36 hmoveto\n-51 callsubr\n84 hmoveto\n-52 callsubr\n60 hmoveto\n-53 callsubr\n-67 callsubr\n-101 callsubr\n36 hmoveto\n-52 callsubr\n36 hmoveto\n-52 callsubr\n24 hmoveto\n85 callsubr\n-102 callsubr\n-1332 -12 rmoveto\n-76 callsubr\n36 hmoveto\n-52 callsubr\n24 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n84 hmoveto\n-53 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-53 callsubr\n84 hmoveto\n-51 callsubr\n36 hmoveto\n-51 callsubr\n84 hmoveto\n-52 callsubr\n60 hmoveto\n-53 callsubr\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-74 callsubr\n-53 callsubr\n36 hmoveto\n-51 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n85 callsubr\n-1320 -12 rmoveto\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-49 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-47 callsubr\n36 hmoveto\n-51 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-52 callsubr\n60 hmoveto\n-53 callsubr\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-74 callsubr\n-53 callsubr\n36 hmoveto\n-51 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-76 callsubr\n-1320 -12 rmoveto\n-75 callsubr\n-101 callsubr\n60 hmoveto\n-52 callsubr\n60 hmoveto\n-51 callsubr\n84 hmoveto\n-53 callsubr\n72 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-53 callsubr\n72 hmoveto\n-52 callsubr\n72 hmoveto\n-53 callsubr\n84 hmoveto\n-51 callsubr\n36 hmoveto\n-52 callsubr\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-74 callsubr\n72 hmoveto\n-51 callsubr\n60 hmoveto\n85 callsubr\n-102 callsubr\n-1308 -12 rmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n-51 callsubr\n48 hmoveto\n-50 callsubr\n72 hmoveto\n-52 callsubr\n60 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-53 callsubr\n72 hmoveto\n-52 callsubr\n72 hmoveto\n-53 callsubr\n96 hmoveto\n-52 callsubr\n36 hmoveto\n-53 callsubr\n-75 callsubr\n-101 callsubr\n36 hmoveto\n-74 callsubr\n72 hmoveto\n-51 callsubr\n48 hmoveto\n85 callsubr\n-76 callsubr\n-1308 -12 rmoveto\n-75 callsubr\n-49 callsubr\n16 callsubr\n-31 callsubr\n-31 callsubr\n-39 callsubr\n36 hmoveto\n85 callsubr\n-74 callsubr\n-52 callsubr\n-74 callsubr\n-48 callsubr\n-76 callsubr\n-49 callsubr\n-76 callsubr\n-1284 -12 rmoveto\n-58 callsubr\n-40 callsubr\n-68 callsubr\n-49 callsubr\n-74 callsubr\n-49 callsubr\n16 callsubr\n-45 callsubr\n36 hmoveto\n85 callsubr\n-69 callsubr\n12 hmoveto\n-60 callsubr\n-1248 -12 rmoveto\n-54 callsubr\n-54 callsubr\n-57 callsubr\n-101 callsubr\n48 hmoveto\n85 callsubr\n-75 callsubr\n108 hmoveto\n-63 callsubr\n-1116 -12 rmoveto\n-54 callsubr\n-54 callsubr\n-66 callsubr\n36 hmoveto\n85 callsubr\n-76 callsubr\n-660 -12 rmoveto\n-68 callsubr\n360 hmoveto\n-64 callsubr\n-84 -12 rmoveto\n-72 callsubr\n",
        "initialPosition": {
            "x": 44,
            "y": 14
        },
        "endPosition": {
            "x": 85,
            "y": 35
        }
    },
    "Run0022.coderelay.png": {
        "commands":
        "-101 callsubr\n39 callsubr\n-103 callsubr\n-72 -12 rmoveto\n62 callsubr\n-97 callsubr\n-102 callsubr\n-84 -12 rmoveto\n-98 callsubr\n24 hmoveto\n85 callsubr\n-96 -12 rmoveto\n39 callsubr\n-101 callsubr\n48 hmoveto\n-102 callsubr\n-132 -12 rmoveto\n85 callsubr\n-99 callsubr\n-102 callsubr\n60 hmoveto\n-7 callsubr\n-156 -12 rmoveto\n39 callsubr\n-30 callsubr\n72 hmoveto\n63 callsubr\n-168 -12 rmoveto\n-99 callsubr\n-101 callsubr\n96 hmoveto\n39 callsubr\n-180 -12 rmoveto\n39 callsubr\n-103 callsubr\n12 hmoveto\n-53 callsubr\n-102 callsubr\n60 hmoveto\n62 callsubr\n-102 callsubr\n-372 -12 rmoveto\n-102 callsubr\n156 hmoveto\n39 callsubr\n-97 callsubr\n-75 callsubr\n48 hmoveto\n62 callsubr\n-7 callsubr\n-384 -12 rmoveto\n62 callsubr\n-102 callsubr\n120 hmoveto\n62 callsubr\n16 callsubr\n-101 callsubr\n84 hmoveto\n39 callsubr\n-98 callsubr\n-102 callsubr\n-384 -12 rmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n84 hmoveto\n86 callsubr\n132 hmoveto\n-98 callsubr\n-76 callsubr\n-372 -12 rmoveto\n-96 callsubr\n-102 callsubr\n60 hmoveto\n-76 callsubr\n-101 callsubr\n24 hmoveto\n40 callsubr\n-53 callsubr\n39 callsubr\n-103 callsubr\n12 hmoveto\n39 callsubr\n-324 -12 rmoveto\n-98 callsubr\n39 callsubr\n-30 callsubr\n24 hmoveto\n86 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-99 callsubr\n16 callsubr\n-98 callsubr\n24 hmoveto\n-30 callsubr\n-312 -12 rmoveto\n-98 callsubr\n39 callsubr\n-99 callsubr\n12 hmoveto\n-76 callsubr\n-101 callsubr\n12 hmoveto\n41 callsubr\n84 hmoveto\n39 callsubr\n-288 -12 rmoveto\n-98 callsubr\n39 callsubr\n-30 callsubr\n16 callsubr\n12 hmoveto\n41 callsubr\n-103 callsubr\n72 hmoveto\n-99 callsubr\n-102 callsubr\n-276 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-98 callsubr\n12 hmoveto\n39 callsubr\n-103 callsubr\n12 hmoveto\n-7 callsubr\n60 hmoveto\n40 callsubr\n-252 -12 rmoveto\n-99 callsubr\n-76 callsubr\n12 hmoveto\n-99 callsubr\n16 callsubr\n12 hmoveto\n39 callsubr\n72 hmoveto\n-30 callsubr\n-228 -12 rmoveto\n-99 callsubr\n-102 callsubr\n12 hmoveto\n-98 callsubr\n24 hmoveto\n-99 callsubr\n48 hmoveto\n62 callsubr\n-103 callsubr\n-228 -12 rmoveto\n-99 callsubr\n-102 callsubr\n24 hmoveto\n39 callsubr\n-99 callsubr\n12 hmoveto\n-103 callsubr\n60 hmoveto\n-99 callsubr\n-101 callsubr\n-240 -12 rmoveto\n-6 callsubr\n-98 callsubr\n-76 callsubr\n-98 callsubr\n60 hmoveto\n-99 callsubr\n-102 callsubr\n-228 -12 rmoveto\n-27 callsubr\n-99 callsubr\n-76 callsubr\n-99 callsubr\n-102 callsubr\n48 hmoveto\n-99 callsubr\n-156 -12 rmoveto\n62 callsubr\n-29 callsubr\n-99 callsubr\n-101 callsubr\n36 hmoveto\n-30 callsubr\n-144 -12 rmoveto\n39 callsubr\n-29 callsubr\n-99 callsubr\n-101 callsubr\n24 hmoveto\n-99 callsubr\n-102 callsubr\n-144 -12 rmoveto\n-98 callsubr\n39 callsubr\n-99 callsubr\n24 hmoveto\n62 callsubr\n-99 callsubr\n-144 -12 rmoveto\n-96 callsubr\n-101 callsubr\n48 hmoveto\n-98 callsubr\n-144 -12 rmoveto\n-97 callsubr\n84 hmoveto\n-7 callsubr\n-156 -12 rmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n72 hmoveto\n39 callsubr\n-101 callsubr\n-180 -12 rmoveto\n85 callsubr\n-96 callsubr\n85 callsubr\n48 hmoveto\n39 callsubr\n-103 callsubr\n-192 -12 rmoveto\n-91 callsubr\n48 hmoveto\n39 callsubr\n-101 callsubr\n-216 -12 rmoveto\n-30 callsubr\n12 hmoveto\n62 callsubr\n-95 callsubr\n-102 callsubr\n48 hmoveto\n-99 callsubr\n-102 callsubr\n-240 -12 rmoveto\n-99 callsubr\n192 hmoveto\n-99 callsubr\n-252 -12 rmoveto\n-99 callsubr\n-53 callsubr\n-75 callsubr\n144 hmoveto\n40 callsubr\n-264 -12 rmoveto\n-96 callsubr\n-76 callsubr\n-97 callsubr\n-102 callsubr\n60 hmoveto\n85 callsubr\n-98 callsubr\n-264 -12 rmoveto\n-76 callsubr\n86 callsubr\n24 hmoveto\n62 callsubr\n-99 callsubr\n62 callsubr\n-97 callsubr\n39 callsubr\n-99 callsubr\n-101 callsubr\n-228 -12 rmoveto\n-102 callsubr\n48 hmoveto\n63 callsubr\n-108 -12 rmoveto\n62 callsubr\n48 hmoveto\n-102 callsubr\n-84 -12 rmoveto\n-99 callsubr\n36 hmoveto\n39 callsubr\n-96 -12 rmoveto\n63 callsubr\n24 hmoveto\n63 callsubr\n-96 -12 rmoveto\n-76 callsubr\n36 hmoveto\n-7 callsubr\n-84 -12 rmoveto\n-103 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n-96 -12 rmoveto\n-76 callsubr\n36 hmoveto\n-30 callsubr\n-84 -12 rmoveto\n-101 callsubr\n36 hmoveto\n63 callsubr\n-96 -12 rmoveto\n-99 callsubr\n36 hmoveto\n39 callsubr\n-84 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-30 callsubr\n-84 -12 rmoveto\n-103 callsubr\n36 hmoveto\n85 callsubr\n-84 -12 rmoveto\n39 callsubr\n36 hmoveto\n39 callsubr\n-84 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-30 callsubr\n-96 -12 rmoveto\n39 callsubr\n36 hmoveto\n39 callsubr\n-96 -12 rmoveto\n63 callsubr\n36 hmoveto\n-7 callsubr\n-96 -12 rmoveto\n39 callsubr\n48 hmoveto\n-99 callsubr\n-96 -12 rmoveto\n-103 callsubr\n72 hmoveto\n-99 callsubr\n-101 callsubr\n-120 -12 rmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n62 callsubr\n-7 callsubr\n-132 -12 rmoveto\n63 callsubr\n40 callsubr\n24 hmoveto\n39 callsubr\n-103 callsubr\n-84 -12 rmoveto\n62 callsubr\n-7 callsubr\n12 hmoveto\n-99 callsubr\n-101 callsubr\n-72 -12 rmoveto\n39 callsubr\n-97 callsubr\n",
        "initialPosition": {
            "x": 40,
            "y": 8
        },
        "endPosition": {
            "x": 27,
            "y": 62
        }
    },
    "codeRelayLogo40000.coderelay.png": {
        "commands":
        "-102 callsubr\n-73 callsubr\n-492 -12 rmoveto\n-73 callsubr\n324 hmoveto\n-67 callsubr\n-528 -12 rmoveto\n-101 callsubr\n60 hmoveto\n-102 callsubr\n144 hmoveto\n-75 callsubr\n-101 callsubr\n24 hmoveto\n-76 callsubr\n48 hmoveto\n-75 callsubr\n-101 callsubr\n84 hmoveto\n-75 callsubr\n96 hmoveto\n-101 callsubr\n48 hmoveto\n-102 callsubr\n372 hmoveto\n-102 callsubr\n24 hmoveto\n-101 callsubr\n-1140 -12 rmoveto\n16 callsubr\n60 hmoveto\n85 callsubr\n-102 callsubr\n108 hmoveto\n-74 callsubr\n36 hmoveto\n-69 callsubr\n-101 callsubr\n84 hmoveto\n85 callsubr\n-69 callsubr\n-101 callsubr\n48 hmoveto\n-75 callsubr\n348 hmoveto\n-101 callsubr\n-1116 -12 rmoveto\n16 callsubr\n84 hmoveto\n-65 callsubr\n-53 callsubr\n36 hmoveto\n85 callsubr\n-74 callsubr\n-51 callsubr\n96 hmoveto\n85 callsubr\n-69 callsubr\n-101 callsubr\n36 hmoveto\n-64 callsubr\n216 hmoveto\n16 callsubr\n12 hmoveto\n85 callsubr\n-69 callsubr\n-1272 -12 rmoveto\n16 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n85 callsubr\n16 callsubr\n-52 callsubr\n-73 callsubr\n-52 callsubr\n36 hmoveto\n-45 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-47 callsubr\n-74 callsubr\n36 hmoveto\n-73 callsubr\n-50 callsubr\n-76 callsubr\n-52 callsubr\n-75 callsubr\n-53 callsubr\n144 hmoveto\n-51 callsubr\n-73 callsubr\n-51 callsubr\n-76 callsubr\n-1296 -12 rmoveto\n16 callsubr\n36 hmoveto\n-50 callsubr\n-76 callsubr\n-101 callsubr\n48 hmoveto\n85 callsubr\n-76 callsubr\n-101 callsubr\n72 hmoveto\n-52 callsubr\n60 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n24 hmoveto\n-51 callsubr\n60 hmoveto\n85 callsubr\n16 callsubr\n36 hmoveto\n-74 callsubr\n-101 callsubr\n60 hmoveto\n85 callsubr\n36 hmoveto\n-76 callsubr\n-101 callsubr\n24 hmoveto\n-101 callsubr\n120 hmoveto\n-101 callsubr\n36 hmoveto\n85 callsubr\n-75 callsubr\n-101 callsubr\n48 hmoveto\n85 callsubr\n-102 callsubr\n-1308 -12 rmoveto\n16 callsubr\n36 hmoveto\n-52 callsubr\n-75 callsubr\n-101 callsubr\n60 hmoveto\n-51 callsubr\n84 hmoveto\n-53 callsubr\n72 hmoveto\n-53 callsubr\n84 hmoveto\n-52 callsubr\n72 hmoveto\n-51 callsubr\n36 hmoveto\n-50 callsubr\n60 hmoveto\n-53 callsubr\n36 hmoveto\n-52 callsubr\n24 hmoveto\n85 callsubr\n108 hmoveto\n-101 callsubr\n48 hmoveto\n-75 callsubr\n-53 callsubr\n60 hmoveto\n85 callsubr\n-1308 -12 rmoveto\n16 callsubr\n36 hmoveto\n-52 callsubr\n-76 callsubr\n-53 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n72 hmoveto\n-52 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-52 callsubr\n36 hmoveto\n-47 callsubr\n36 hmoveto\n-53 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-75 callsubr\n84 hmoveto\n-76 callsubr\n-101 callsubr\n36 hmoveto\n16 callsubr\n-53 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n85 callsubr\n-102 callsubr\n-1320 -12 rmoveto\n16 callsubr\n36 hmoveto\n-49 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n96 hmoveto\n-101 callsubr\n72 hmoveto\n-52 callsubr\n96 hmoveto\n-52 callsubr\n36 hmoveto\n-50 callsubr\n72 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-75 callsubr\n84 hmoveto\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-51 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n85 callsubr\n-1320 -12 rmoveto\n16 callsubr\n36 hmoveto\n-49 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-101 callsubr\n96 hmoveto\n-101 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n96 hmoveto\n-52 callsubr\n36 hmoveto\n-51 callsubr\n84 hmoveto\n-52 callsubr\n60 hmoveto\n85 callsubr\n-73 callsubr\n36 hmoveto\n-75 callsubr\n-101 callsubr\n36 hmoveto\n-52 callsubr\n36 hmoveto\n-52 callsubr\n24 hmoveto\n85 callsubr\n-1320 -12 rmoveto\n-76 callsubr\n36 hmoveto\n-52 callsubr\n24 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n84 hmoveto\n-53 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-53 callsubr\n84 hmoveto\n-51 callsubr\n36 hmoveto\n-51 callsubr\n84 hmoveto\n-52 callsubr\n60 hmoveto\n85 callsubr\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-73 callsubr\n-101 callsubr\n36 hmoveto\n-51 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n85 callsubr\n-1308 -12 rmoveto\n16 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-49 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-47 callsubr\n36 hmoveto\n-51 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-52 callsubr\n60 hmoveto\n85 callsubr\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-74 callsubr\n-53 callsubr\n36 hmoveto\n-51 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-76 callsubr\n-1308 -12 rmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n-52 callsubr\n60 hmoveto\n-51 callsubr\n84 hmoveto\n-53 callsubr\n72 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-53 callsubr\n72 hmoveto\n-52 callsubr\n72 hmoveto\n-53 callsubr\n84 hmoveto\n-51 callsubr\n36 hmoveto\n85 callsubr\n-75 callsubr\n-101 callsubr\n36 hmoveto\n-74 callsubr\n72 hmoveto\n-51 callsubr\n60 hmoveto\n85 callsubr\n-102 callsubr\n-1296 -12 rmoveto\n16 callsubr\n60 hmoveto\n86 callsubr\n-101 callsubr\n48 hmoveto\n85 callsubr\n-76 callsubr\n-101 callsubr\n72 hmoveto\n-52 callsubr\n60 hmoveto\n-53 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-52 callsubr\n60 hmoveto\n-52 callsubr\n72 hmoveto\n-52 callsubr\n72 hmoveto\n-51 callsubr\n36 hmoveto\n85 callsubr\n-75 callsubr\n-101 callsubr\n36 hmoveto\n-102 callsubr\n12 hmoveto\n-76 callsubr\n72 hmoveto\n85 callsubr\n16 callsubr\n48 hmoveto\n85 callsubr\n-102 callsubr\n-1272 -12 rmoveto\n16 callsubr\n-50 callsubr\n-75 callsubr\n-50 callsubr\n-74 callsubr\n-41 callsubr\n-76 callsubr\n-52 callsubr\n-76 callsubr\n-52 callsubr\n-76 callsubr\n-49 callsubr\n-76 callsubr\n-48 callsubr\n-76 callsubr\n-44 callsubr\n36 hmoveto\n-74 callsubr\n24 hmoveto\n-52 callsubr\n48 hmoveto\n-48 callsubr\n-75 callsubr\n-50 callsubr\n-102 callsubr\n-1248 -12 rmoveto\n-54 callsubr\n-54 callsubr\n-56 callsubr\n-101 callsubr\n36 hmoveto\n85 callsubr\n-76 callsubr\n132 hmoveto\n-64 callsubr\n-1212 -12 rmoveto\n-75 callsubr\n48 hmoveto\n-76 callsubr\n84 hmoveto\n-63 callsubr\n120 hmoveto\n-71 callsubr\n36 hmoveto\n-62 callsubr\n-101 callsubr\n48 hmoveto\n85 callsubr\n-102 callsubr\n168 hmoveto\n-76 callsubr\n72 hmoveto\n-102 callsubr\n-384 -12 rmoveto\n-76 callsubr\n36 hmoveto\n85 callsubr\n-48 -12 rmoveto\n-76 callsubr\n",
        "initialPosition": {
            "x": 46,
            "y": 15
        },
        "endPosition": {
            "x": 83,
            "y": 34
        }
    },
    "Run0023.coderelay.png": {
        "commands":
        "-101 callsubr\n-99 callsubr\n-102 callsubr\n-60 -12 rmoveto\n62 callsubr\n-97 callsubr\n-84 -12 rmoveto\n62 callsubr\n-103 callsubr\n36 hmoveto\n-30 callsubr\n-384 -12 rmoveto\n39 callsubr\n-101 callsubr\n240 hmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n-99 callsubr\n-408 -12 rmoveto\n62 callsubr\n-98 callsubr\n228 hmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n62 callsubr\n-103 callsubr\n-408 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-7 callsubr\n156 hmoveto\n85 callsubr\n-97 callsubr\n-102 callsubr\n60 hmoveto\n39 callsubr\n-103 callsubr\n-408 -12 rmoveto\n-98 callsubr\n39 callsubr\n-103 callsubr\n84 hmoveto\n87 callsubr\n-96 callsubr\n16 callsubr\n84 hmoveto\n39 callsubr\n-396 -12 rmoveto\n62 callsubr\n-29 callsubr\n-30 callsubr\n60 hmoveto\n39 callsubr\n-7 callsubr\n-75 callsubr\n-101 callsubr\n132 hmoveto\n-99 callsubr\n-384 -12 rmoveto\n-98 callsubr\n39 callsubr\n-103 callsubr\n36 hmoveto\n62 callsubr\n-103 callsubr\n192 hmoveto\n39 callsubr\n-103 callsubr\n-372 -12 rmoveto\n62 callsubr\n-29 callsubr\n-30 callsubr\n12 hmoveto\n-99 callsubr\n-101 callsubr\n36 hmoveto\n62 callsubr\n-98 callsubr\n-102 callsubr\n72 hmoveto\n-97 callsubr\n-348 -12 rmoveto\n39 callsubr\n-29 callsubr\n-99 callsubr\n-102 callsubr\n24 hmoveto\n62 callsubr\n-92 callsubr\n-101 callsubr\n36 hmoveto\n-103 callsubr\n-300 -12 rmoveto\n-99 callsubr\n-76 callsubr\n36 hmoveto\n-73 callsubr\n-101 callsubr\n12 hmoveto\n-103 callsubr\n96 hmoveto\n62 callsubr\n-288 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n39 callsubr\n96 hmoveto\n62 callsubr\n-324 -12 rmoveto\n62 callsubr\n16 callsubr\n24 hmoveto\n39 callsubr\n-103 callsubr\n72 hmoveto\n-99 callsubr\n96 hmoveto\n-30 callsubr\n-336 -12 rmoveto\n62 callsubr\n-30 callsubr\n39 callsubr\n-29 callsubr\n-103 callsubr\n72 hmoveto\n-30 callsubr\n84 hmoveto\n62 callsubr\n-312 -12 rmoveto\n62 callsubr\n24 hmoveto\n-99 callsubr\n-76 callsubr\n-103 callsubr\n60 hmoveto\n63 callsubr\n84 hmoveto\n-99 callsubr\n-102 callsubr\n-276 -12 rmoveto\n39 callsubr\n-30 callsubr\n39 callsubr\n-103 callsubr\n36 hmoveto\n39 callsubr\n84 hmoveto\n62 callsubr\n39 callsubr\n-103 callsubr\n-276 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-99 callsubr\n-102 callsubr\n12 hmoveto\n62 callsubr\n-102 callsubr\n84 hmoveto\n-7 callsubr\n12 hmoveto\n-98 callsubr\n-288 -12 rmoveto\n62 callsubr\n-30 callsubr\n39 callsubr\n-103 callsubr\n12 hmoveto\n-99 callsubr\n84 hmoveto\n39 callsubr\n-30 callsubr\n39 callsubr\n-96 callsubr\n-324 -12 rmoveto\n-98 callsubr\n39 callsubr\n-6 callsubr\n-103 callsubr\n72 hmoveto\n87 callsubr\n-98 callsubr\n-76 callsubr\n-97 callsubr\n-336 -12 rmoveto\n62 callsubr\n-29 callsubr\n-99 callsubr\n-102 callsubr\n72 hmoveto\n39 callsubr\n36 hmoveto\n62 callsubr\n-94 callsubr\n-102 callsubr\n-336 -12 rmoveto\n39 callsubr\n-97 callsubr\n84 hmoveto\n-99 callsubr\n72 hmoveto\n85 callsubr\n39 callsubr\n-98 callsubr\n-324 -12 rmoveto\n-97 callsubr\n-102 callsubr\n84 hmoveto\n-99 callsubr\n-76 callsubr\n96 hmoveto\n63 callsubr\n-300 -12 rmoveto\n-99 callsubr\n-101 callsubr\n96 hmoveto\n-53 callsubr\n-98 callsubr\n-76 callsubr\n-101 callsubr\n-228 -12 rmoveto\n39 callsubr\n144 hmoveto\n85 callsubr\n39 callsubr\n-30 callsubr\n-228 -12 rmoveto\n-98 callsubr\n-76 callsubr\n144 hmoveto\n40 callsubr\n-252 -12 rmoveto\n62 callsubr\n-96 callsubr\n-101 callsubr\n132 hmoveto\n-99 callsubr\n-264 -12 rmoveto\n-98 callsubr\n17 callsubr\n-98 callsubr\n-102 callsubr\n132 hmoveto\n-99 callsubr\n-288 -12 rmoveto\n62 callsubr\n72 hmoveto\n-96 callsubr\n-102 callsubr\n96 hmoveto\n62 callsubr\n-102 callsubr\n-300 -12 rmoveto\n-30 callsubr\n72 hmoveto\n-103 callsubr\n12 hmoveto\n-29 callsubr\n-98 callsubr\n84 hmoveto\n16 callsubr\n-300 -12 rmoveto\n-103 callsubr\n72 hmoveto\n-76 callsubr\n36 hmoveto\n39 callsubr\n-99 callsubr\n72 hmoveto\n85 callsubr\n-300 -12 rmoveto\n-99 callsubr\n72 hmoveto\n-7 callsubr\n24 hmoveto\n39 callsubr\n-99 callsubr\n72 hmoveto\n-99 callsubr\n-101 callsubr\n-312 -12 rmoveto\n62 callsubr\n-102 callsubr\n48 hmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n39 callsubr\n-30 callsubr\n72 hmoveto\n-99 callsubr\n-101 callsubr\n-300 -12 rmoveto\n39 callsubr\n60 hmoveto\n-99 callsubr\n24 hmoveto\n39 callsubr\n-7 callsubr\n48 hmoveto\n62 callsubr\n-102 callsubr\n-276 -12 rmoveto\n63 callsubr\n48 hmoveto\n39 callsubr\n24 hmoveto\n39 callsubr\n-7 callsubr\n48 hmoveto\n-76 callsubr\n-101 callsubr\n-264 -12 rmoveto\n-76 callsubr\n36 hmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n24 hmoveto\n85 callsubr\n-102 callsubr\n-252 -12 rmoveto\n85 callsubr\n-102 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n24 hmoveto\n39 callsubr\n-101 callsubr\n-240 -12 rmoveto\n39 callsubr\n48 hmoveto\n-103 callsubr\n48 hmoveto\n-103 callsubr\n48 hmoveto\n85 callsubr\n-228 -12 rmoveto\n39 callsubr\n-101 callsubr\n36 hmoveto\n-101 callsubr\n60 hmoveto\n-76 callsubr\n36 hmoveto\n-30 callsubr\n-228 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-99 callsubr\n60 hmoveto\n85 callsubr\n36 hmoveto\n-103 callsubr\n-228 -12 rmoveto\n62 callsubr\n36 hmoveto\n62 callsubr\n84 hmoveto\n-102 callsubr\n24 hmoveto\n39 callsubr\n-228 -12 rmoveto\n39 callsubr\n36 hmoveto\n-103 callsubr\n96 hmoveto\n-99 callsubr\n12 hmoveto\n-30 callsubr\n-228 -12 rmoveto\n-30 callsubr\n24 hmoveto\n-30 callsubr\n96 hmoveto\n39 callsubr\n63 callsubr\n-240 -12 rmoveto\n62 callsubr\n24 hmoveto\n85 callsubr\n120 hmoveto\n-98 callsubr\n-228 -12 rmoveto\n-7 callsubr\n12 hmoveto\n85 callsubr\n156 hmoveto\n-103 callsubr\n-252 -12 rmoveto\n62 callsubr\n-103 callsubr\n12 hmoveto\n-53 callsubr\n-72 -12 rmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n16 callsubr\n-84 -12 rmoveto\n40 callsubr\n24 hmoveto\n-102 callsubr\n-72 -12 rmoveto\n-99 callsubr\n-24 -12 rmoveto\n-102 callsubr\n48 hmoveto\n-102 callsubr\n-72 -12 rmoveto\n-53 callsubr\n24 hmoveto\n-76 callsubr\n-72 -12 rmoveto\n62 callsubr\n24 hmoveto\n-30 callsubr\n-60 -12 rmoveto\n-30 callsubr\n12 hmoveto\n-7 callsubr\n-60 -12 rmoveto\n64 callsubr\n-103 callsubr\n-48 -12 rmoveto\n-30 callsubr\n40 callsubr\n-60 -12 rmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n",
        "initialPosition": {
            "x": 40,
            "y": 8
        },
        "endPosition": {
            "x": 16,
            "y": 63
        }
    },
    "codeRelayLogo30000.coderelay.png": {
        "commands":
        "-101 callsubr\n252 hmoveto\n-101 callsubr\n132 hmoveto\n-101 callsubr\n216 hmoveto\n-102 callsubr\n432 hmoveto\n-102 callsubr\n24 hmoveto\n-101 callsubr\n-1128 -12 rmoveto\n-101 callsubr\n60 hmoveto\n-101 callsubr\n324 hmoveto\n-101 callsubr\n84 hmoveto\n-101 callsubr\n120 hmoveto\n-101 callsubr\n432 hmoveto\n-101 callsubr\n-1104 -12 rmoveto\n-101 callsubr\n240 hmoveto\n-76 callsubr\n36 hmoveto\n-76 callsubr\n48 hmoveto\n-75 callsubr\n-101 callsubr\n96 hmoveto\n-102 callsubr\n120 hmoveto\n-101 callsubr\n432 hmoveto\n-101 callsubr\n12 hmoveto\n-101 callsubr\n-1140 -12 rmoveto\n-101 callsubr\n24 hmoveto\n85 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n-51 callsubr\n60 hmoveto\n-52 callsubr\n36 hmoveto\n-75 callsubr\n-50 callsubr\n16 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-76 callsubr\n-49 callsubr\n36 hmoveto\n-102 callsubr\n96 hmoveto\n-50 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-53 callsubr\n144 hmoveto\n-51 callsubr\n60 hmoveto\n-51 callsubr\n-1260 -12 rmoveto\n-101 callsubr\n36 hmoveto\n86 callsubr\n-53 callsubr\n24 hmoveto\n-101 callsubr\n48 hmoveto\n-101 callsubr\n36 hmoveto\n-101 callsubr\n72 hmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n16 callsubr\n24 hmoveto\n-52 callsubr\n24 hmoveto\n85 callsubr\n16 callsubr\n60 hmoveto\n-102 callsubr\n12 hmoveto\n-76 callsubr\n36 hmoveto\n-102 callsubr\n36 hmoveto\n-101 callsubr\n60 hmoveto\n-76 callsubr\n36 hmoveto\n-76 callsubr\n-101 callsubr\n24 hmoveto\n-101 callsubr\n120 hmoveto\n-101 callsubr\n36 hmoveto\n-101 callsubr\n48 hmoveto\n-101 callsubr\n48 hmoveto\n-101 callsubr\n-1272 -12 rmoveto\n-101 callsubr\n36 hmoveto\n-74 callsubr\n12 hmoveto\n16 callsubr\n60 hmoveto\n85 callsubr\n16 callsubr\n84 hmoveto\n-53 callsubr\n72 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n86 callsubr\n72 hmoveto\n85 callsubr\n-76 callsubr\n36 hmoveto\n-74 callsubr\n-101 callsubr\n60 hmoveto\n85 callsubr\n36 hmoveto\n86 callsubr\n24 hmoveto\n-101 callsubr\n120 hmoveto\n-101 callsubr\n72 hmoveto\n16 callsubr\n-101 callsubr\n60 hmoveto\n-101 callsubr\n-1284 -12 rmoveto\n-101 callsubr\n36 hmoveto\n-75 callsubr\n24 hmoveto\n16 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n86 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n72 hmoveto\n85 callsubr\n-102 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-75 callsubr\n36 hmoveto\n-73 callsubr\n-52 callsubr\n36 hmoveto\n16 callsubr\n24 hmoveto\n85 callsubr\n180 hmoveto\n-101 callsubr\n36 hmoveto\n-75 callsubr\n-101 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n-101 callsubr\n-1284 -12 rmoveto\n-101 callsubr\n36 hmoveto\n-73 callsubr\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n96 hmoveto\n-101 callsubr\n72 hmoveto\n86 callsubr\n96 hmoveto\n-75 callsubr\n36 hmoveto\n-74 callsubr\n-101 callsubr\n72 hmoveto\n16 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-102 callsubr\n132 hmoveto\n-101 callsubr\n36 hmoveto\n-75 callsubr\n-101 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n-1296 -12 rmoveto\n-101 callsubr\n36 hmoveto\n-73 callsubr\n-101 callsubr\n36 hmoveto\n-76 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n-52 callsubr\n36 hmoveto\n-101 callsubr\n96 hmoveto\n-101 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n86 callsubr\n96 hmoveto\n-75 callsubr\n36 hmoveto\n-74 callsubr\n84 hmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n85 callsubr\n132 hmoveto\n-101 callsubr\n36 hmoveto\n-75 callsubr\n36 hmoveto\n-52 callsubr\n24 hmoveto\n-101 callsubr\n-1248 -12 rmoveto\n86 callsubr\n24 hmoveto\n-102 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-102 callsubr\n36 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n84 hmoveto\n-53 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n16 callsubr\n84 hmoveto\n85 callsubr\n-76 callsubr\n36 hmoveto\n-75 callsubr\n-101 callsubr\n84 hmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n85 callsubr\n24 hmoveto\n-101 callsubr\n84 hmoveto\n16 callsubr\n36 hmoveto\n-75 callsubr\n-101 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-101 callsubr\n-1284 -12 rmoveto\n-101 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-53 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n86 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-53 callsubr\n24 hmoveto\n-49 callsubr\n24 hmoveto\n85 callsubr\n36 hmoveto\n85 callsubr\n36 hmoveto\n-51 callsubr\n-75 callsubr\n-101 callsubr\n36 hmoveto\n85 callsubr\n16 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n-76 callsubr\n24 hmoveto\n-101 callsubr\n84 hmoveto\n-53 callsubr\n36 hmoveto\n85 callsubr\n16 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n-101 callsubr\n-1260 -12 rmoveto\n-101 callsubr\n60 hmoveto\n-52 callsubr\n60 hmoveto\n-53 callsubr\n16 callsubr\n84 hmoveto\n16 callsubr\n72 hmoveto\n16 callsubr\n24 hmoveto\n86 callsubr\n36 hmoveto\n16 callsubr\n72 hmoveto\n-76 callsubr\n-101 callsubr\n72 hmoveto\n16 callsubr\n84 hmoveto\n85 callsubr\n16 callsubr\n36 hmoveto\n85 callsubr\n36 hmoveto\n-101 callsubr\n156 hmoveto\n85 callsubr\n16 callsubr\n60 hmoveto\n-101 callsubr\n-1260 -12 rmoveto\n-101 callsubr\n60 hmoveto\n85 callsubr\n16 callsubr\n48 hmoveto\n85 callsubr\n-76 callsubr\n-101 callsubr\n72 hmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n16 callsubr\n24 hmoveto\n86 callsubr\n36 hmoveto\n-76 callsubr\n-101 callsubr\n60 hmoveto\n-76 callsubr\n-101 callsubr\n72 hmoveto\n-76 callsubr\n-101 callsubr\n72 hmoveto\n85 callsubr\n16 callsubr\n36 hmoveto\n-101 callsubr\n48 hmoveto\n-101 callsubr\n156 hmoveto\n85 callsubr\n16 callsubr\n48 hmoveto\n-101 callsubr\n-1236 -12 rmoveto\n-49 callsubr\n36 hmoveto\n-50 callsubr\n48 hmoveto\n-49 callsubr\n-75 callsubr\n-50 callsubr\n24 hmoveto\n-53 callsubr\n-102 callsubr\n24 hmoveto\n-52 callsubr\n12 hmoveto\n16 callsubr\n-50 callsubr\n24 hmoveto\n-48 callsubr\n24 hmoveto\n-47 callsubr\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-102 callsubr\n60 hmoveto\n-52 callsubr\n48 hmoveto\n-48 callsubr\n36 hmoveto\n-50 callsubr\n-396 -12 rmoveto\n-101 callsubr\n36 hmoveto\n-101 callsubr\n-72 -12 rmoveto\n-102 callsubr\n48 hmoveto\n-101 callsubr\n-24 -12 rmoveto\n-101 callsubr\n",
        "initialPosition": {
            "x": 10,
            "y": 17
        },
        "endPosition": {
            "x": 84,
            "y": 33
        }
    },
    "Run0024.coderelay.png": {
        "commands":
        "-101 callsubr\n-7 callsubr\n276 hmoveto\n39 callsubr\n-6 callsubr\n-103 callsubr\n-396 -12 rmoveto\n39 callsubr\n-98 callsubr\n252 hmoveto\n-98 callsubr\n24 hmoveto\n-99 callsubr\n-102 callsubr\n-408 -12 rmoveto\n-96 callsubr\n240 hmoveto\n-99 callsubr\n-101 callsubr\n36 hmoveto\n62 callsubr\n-103 callsubr\n-408 -12 rmoveto\n-99 callsubr\n39 callsubr\n-103 callsubr\n120 hmoveto\n-53 callsubr\n-76 callsubr\n85 callsubr\n-6 callsubr\n-98 callsubr\n60 hmoveto\n39 callsubr\n-408 -12 rmoveto\n39 callsubr\n-98 callsubr\n-102 callsubr\n60 hmoveto\n85 callsubr\n-90 callsubr\n-102 callsubr\n84 hmoveto\n-99 callsubr\n-396 -12 rmoveto\n-99 callsubr\n39 callsubr\n-103 callsubr\n36 hmoveto\n-99 callsubr\n39 callsubr\n-7 callsubr\n204 hmoveto\n-30 callsubr\n-396 -12 rmoveto\n41 callsubr\n-30 callsubr\n12 hmoveto\n-76 callsubr\n-101 callsubr\n240 hmoveto\n39 callsubr\n-101 callsubr\n-384 -12 rmoveto\n-99 callsubr\n39 callsubr\n-99 callsubr\n-102 callsubr\n240 hmoveto\n85 callsubr\n-7 callsubr\n-372 -12 rmoveto\n-96 callsubr\n-102 callsubr\n60 hmoveto\n85 callsubr\n39 callsubr\n-99 callsubr\n-101 callsubr\n84 hmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n-360 -12 rmoveto\n63 callsubr\n36 hmoveto\n85 callsubr\n39 callsubr\n-90 callsubr\n-102 callsubr\n24 hmoveto\n-98 callsubr\n-76 callsubr\n-396 -12 rmoveto\n-101 callsubr\n12 hmoveto\n-102 callsubr\n60 hmoveto\n39 callsubr\n-98 callsubr\n16 callsubr\n48 hmoveto\n-103 callsubr\n96 hmoveto\n-99 callsubr\n-336 -12 rmoveto\n-76 callsubr\n12 hmoveto\n-99 callsubr\n-76 callsubr\n-7 callsubr\n84 hmoveto\n62 callsubr\n96 hmoveto\n-99 callsubr\n72 hmoveto\n-99 callsubr\n62 callsubr\n-420 -12 rmoveto\n40 callsubr\n39 callsubr\n-103 callsubr\n84 hmoveto\n39 callsubr\n84 hmoveto\n62 callsubr\n-99 callsubr\n-76 callsubr\n-53 callsubr\n-98 callsubr\n12 hmoveto\n-103 callsubr\n-408 -12 rmoveto\n-99 callsubr\n39 callsubr\n-103 callsubr\n84 hmoveto\n39 callsubr\n84 hmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n85 callsubr\n-98 callsubr\n12 hmoveto\n62 callsubr\n-102 callsubr\n-408 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-30 callsubr\n72 hmoveto\n-30 callsubr\n72 hmoveto\n62 callsubr\n48 hmoveto\n-53 callsubr\n24 hmoveto\n-98 callsubr\n-396 -12 rmoveto\n40 callsubr\n39 callsubr\n-103 callsubr\n60 hmoveto\n40 callsubr\n72 hmoveto\n-96 callsubr\n-76 callsubr\n85 callsubr\n-30 callsubr\n-101 callsubr\n-372 -12 rmoveto\n-99 callsubr\n39 callsubr\n-30 callsubr\n48 hmoveto\n39 callsubr\n72 hmoveto\n62 callsubr\n-240 -12 rmoveto\n-98 callsubr\n39 callsubr\n-103 callsubr\n48 hmoveto\n-99 callsubr\n72 hmoveto\n-30 callsubr\n-240 -12 rmoveto\n62 callsubr\n-29 callsubr\n-103 callsubr\n12 hmoveto\n39 callsubr\n-99 callsubr\n72 hmoveto\n-99 callsubr\n-216 -12 rmoveto\n39 callsubr\n-94 callsubr\n84 hmoveto\n-30 callsubr\n-204 -12 rmoveto\n-98 callsubr\n39 callsubr\n-103 callsubr\n108 hmoveto\n85 callsubr\n-99 callsubr\n-180 -12 rmoveto\n-99 callsubr\n-101 callsubr\n108 hmoveto\n85 callsubr\n-7 callsubr\n62 callsubr\n-102 callsubr\n-228 -12 rmoveto\n-99 callsubr\n-102 callsubr\n168 hmoveto\n39 callsubr\n-103 callsubr\n-240 -12 rmoveto\n-97 callsubr\n180 hmoveto\n63 callsubr\n-276 -12 rmoveto\n62 callsubr\n-97 callsubr\n-101 callsubr\n168 hmoveto\n39 callsubr\n-103 callsubr\n-288 -12 rmoveto\n40 callsubr\n-53 callsubr\n-76 callsubr\n-103 callsubr\n168 hmoveto\n39 callsubr\n-103 callsubr\n-312 -12 rmoveto\n62 callsubr\n-103 callsubr\n60 hmoveto\n62 callsubr\n-102 callsubr\n144 hmoveto\n62 callsubr\n-103 callsubr\n-312 -12 rmoveto\n-99 callsubr\n72 hmoveto\n39 callsubr\n-94 callsubr\n17 callsubr\n-102 callsubr\n24 hmoveto\n-99 callsubr\n-101 callsubr\n-324 -12 rmoveto\n63 callsubr\n60 hmoveto\n-76 callsubr\n-51 callsubr\n-76 callsubr\n-95 callsubr\n12 hmoveto\n39 callsubr\n-300 -12 rmoveto\n-99 callsubr\n60 hmoveto\n39 callsubr\n-101 callsubr\n120 hmoveto\n-99 callsubr\n12 hmoveto\n-99 callsubr\n-300 -12 rmoveto\n-30 callsubr\n60 hmoveto\n-99 callsubr\n120 hmoveto\n62 callsubr\n24 hmoveto\n39 callsubr\n-324 -12 rmoveto\n-99 callsubr\n-102 callsubr\n60 hmoveto\n63 callsubr\n120 hmoveto\n-30 callsubr\n24 hmoveto\n39 callsubr\n-360 -12 rmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n72 hmoveto\n-30 callsubr\n132 hmoveto\n-30 callsubr\n24 hmoveto\n-30 callsubr\n-384 -12 rmoveto\n85 callsubr\n-99 callsubr\n-101 callsubr\n72 hmoveto\n62 callsubr\n-102 callsubr\n144 hmoveto\n-30 callsubr\n24 hmoveto\n-30 callsubr\n-396 -12 rmoveto\n39 callsubr\n-30 callsubr\n84 hmoveto\n40 callsubr\n156 hmoveto\n-7 callsubr\n12 hmoveto\n85 callsubr\n-384 -12 rmoveto\n-99 callsubr\n60 hmoveto\n85 callsubr\n39 callsubr\n-30 callsubr\n168 hmoveto\n-103 callsubr\n24 hmoveto\n-30 callsubr\n-396 -12 rmoveto\n39 callsubr\n36 hmoveto\n39 callsubr\n-96 callsubr\n-101 callsubr\n180 hmoveto\n-103 callsubr\n24 hmoveto\n-30 callsubr\n-396 -12 rmoveto\n-7 callsubr\n24 hmoveto\n62 callsubr\n-30 callsubr\n-101 callsubr\n228 hmoveto\n-103 callsubr\n24 hmoveto\n-7 callsubr\n-420 -12 rmoveto\n-76 callsubr\n-101 callsubr\n24 hmoveto\n-76 callsubr\n264 hmoveto\n-76 callsubr\n12 hmoveto\n62 callsubr\n-432 -12 rmoveto\n62 callsubr\n-30 callsubr\n12 hmoveto\n62 callsubr\n-103 callsubr\n264 hmoveto\n39 callsubr\n24 hmoveto\n39 callsubr\n-444 -12 rmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n39 callsubr\n-103 callsubr\n276 hmoveto\n-76 callsubr\n24 hmoveto\n39 callsubr\n-456 -12 rmoveto\n-99 callsubr\n-102 callsubr\n24 hmoveto\n-99 callsubr\n-102 callsubr\n288 hmoveto\n-102 callsubr\n36 hmoveto\n62 callsubr\n-102 callsubr\n-492 -12 rmoveto\n62 callsubr\n48 hmoveto\n40 callsubr\n300 hmoveto\n-103 callsubr\n48 hmoveto\n39 callsubr\n-492 -12 rmoveto\n-76 callsubr\n48 hmoveto\n-30 callsubr\n312 hmoveto\n-30 callsubr\n48 hmoveto\n39 callsubr\n-101 callsubr\n-516 -12 rmoveto\n39 callsubr\n24 hmoveto\n62 callsubr\n-102 callsubr\n324 hmoveto\n62 callsubr\n-102 callsubr\n60 hmoveto\n-7 callsubr\n-528 -12 rmoveto\n85 callsubr\n12 hmoveto\n39 callsubr\n-101 callsubr\n348 hmoveto\n39 callsubr\n-98 callsubr\n12 hmoveto\n86 callsubr\n-528 -12 rmoveto\n64 callsubr\n-102 callsubr\n372 hmoveto\n85 callsubr\n-444 -12 rmoveto\n-99 callsubr\n-102 callsubr\n-24 -12 rmoveto\n-102 callsubr\n",
        "initialPosition": {
            "x": 13,
            "y": 9
        },
        "endPosition": {
            "x": 5,
            "y": 57
        }
    },
    "Run0025.coderelay.png": {
        "commands":
        "-102 callsubr\n-96 callsubr\n-396 -12 rmoveto\n39 callsubr\n-99 callsubr\n-101 callsubr\n240 hmoveto\n62 callsubr\n-99 callsubr\n-73 callsubr\n-420 -12 rmoveto\n-95 callsubr\n228 hmoveto\n39 callsubr\n-30 callsubr\n48 hmoveto\n85 callsubr\n-420 -12 rmoveto\n40 callsubr\n-76 callsubr\n-30 callsubr\n192 hmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n72 hmoveto\n-102 callsubr\n-420 -12 rmoveto\n62 callsubr\n-30 callsubr\n39 callsubr\n-103 callsubr\n144 hmoveto\n86 callsubr\n-98 callsubr\n-102 callsubr\n96 hmoveto\n-102 callsubr\n-408 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-99 callsubr\n108 hmoveto\n39 callsubr\n-96 callsubr\n-102 callsubr\n108 hmoveto\n85 callsubr\n-408 -12 rmoveto\n-98 callsubr\n39 callsubr\n-30 callsubr\n24 hmoveto\n85 callsubr\n-98 callsubr\n39 callsubr\n-98 callsubr\n-102 callsubr\n144 hmoveto\n16 callsubr\n-408 -12 rmoveto\n62 callsubr\n-30 callsubr\n39 callsubr\n-30 callsubr\n40 callsubr\n-102 callsubr\n216 hmoveto\n-75 callsubr\n-384 -12 rmoveto\n39 callsubr\n-29 callsubr\n-99 callsubr\n16 callsubr\n228 hmoveto\n62 callsubr\n-103 callsubr\n-360 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-7 callsubr\n36 hmoveto\n-52 callsubr\n17 callsubr\n-30 callsubr\n-52 callsubr\n-102 callsubr\n36 hmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n-348 -12 rmoveto\n-99 callsubr\n-102 callsubr\n36 hmoveto\n85 callsubr\n-76 callsubr\n-101 callsubr\n36 hmoveto\n-99 callsubr\n96 hmoveto\n-30 callsubr\n-101 callsubr\n-348 -12 rmoveto\n39 callsubr\n-30 callsubr\n24 hmoveto\n40 callsubr\n84 hmoveto\n-103 callsubr\n108 hmoveto\n-7 callsubr\n60 hmoveto\n85 callsubr\n-98 callsubr\n-468 -12 rmoveto\n40 callsubr\n39 callsubr\n-30 callsubr\n39 callsubr\n-103 callsubr\n84 hmoveto\n-103 callsubr\n108 hmoveto\n-98 callsubr\n-74 callsubr\n-96 callsubr\n-468 -12 rmoveto\n85 callsubr\n-29 callsubr\n-30 callsubr\n39 callsubr\n-103 callsubr\n72 hmoveto\n62 callsubr\n108 hmoveto\n-93 callsubr\n12 hmoveto\n40 callsubr\n-420 -12 rmoveto\n39 callsubr\n-29 callsubr\n-7 callsubr\n60 hmoveto\n39 callsubr\n84 hmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n85 callsubr\n-94 callsubr\n-396 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-30 callsubr\n60 hmoveto\n-30 callsubr\n84 hmoveto\n-90 callsubr\n-101 callsubr\n-384 -12 rmoveto\n39 callsubr\n-29 callsubr\n-103 callsubr\n60 hmoveto\n-7 callsubr\n72 hmoveto\n63 callsubr\n-252 -12 rmoveto\n-99 callsubr\n39 callsubr\n-7 callsubr\n36 hmoveto\n39 callsubr\n84 hmoveto\n-76 callsubr\n-228 -12 rmoveto\n-30 callsubr\n39 callsubr\n-103 callsubr\n24 hmoveto\n63 callsubr\n72 hmoveto\n-99 callsubr\n-102 callsubr\n-228 -12 rmoveto\n-96 callsubr\n12 hmoveto\n62 callsubr\n-102 callsubr\n84 hmoveto\n-99 callsubr\n-216 -12 rmoveto\n-96 callsubr\n62 callsubr\n-103 callsubr\n84 hmoveto\n62 callsubr\n-102 callsubr\n-216 -12 rmoveto\n62 callsubr\n-99 callsubr\n12 hmoveto\n-99 callsubr\n-101 callsubr\n84 hmoveto\n39 callsubr\n-103 callsubr\n-156 -12 rmoveto\n-30 callsubr\n-101 callsubr\n96 hmoveto\n41 callsubr\n-101 callsubr\n-192 -12 rmoveto\n-99 callsubr\n-102 callsubr\n132 hmoveto\n-98 callsubr\n-204 -12 rmoveto\n-98 callsubr\n-101 callsubr\n132 hmoveto\n39 callsubr\n-7 callsubr\n-228 -12 rmoveto\n-97 callsubr\n-102 callsubr\n132 hmoveto\n62 callsubr\n-99 callsubr\n-252 -12 rmoveto\n39 callsubr\n12 hmoveto\n-98 callsubr\n-102 callsubr\n144 hmoveto\n39 callsubr\n-103 callsubr\n-276 -12 rmoveto\n39 callsubr\n-101 callsubr\n36 hmoveto\n39 callsubr\n-30 callsubr\n132 hmoveto\n-99 callsubr\n-102 callsubr\n-288 -12 rmoveto\n-99 callsubr\n48 hmoveto\n62 callsubr\n39 callsubr\n-98 callsubr\n-102 callsubr\n96 hmoveto\n-99 callsubr\n-300 -12 rmoveto\n-99 callsubr\n60 hmoveto\n39 callsubr\n24 hmoveto\n-95 callsubr\n16 callsubr\n48 hmoveto\n39 callsubr\n-103 callsubr\n-324 -12 rmoveto\n62 callsubr\n-102 callsubr\n48 hmoveto\n63 callsubr\n60 hmoveto\n-53 callsubr\n39 callsubr\n-99 callsubr\n36 hmoveto\n62 callsubr\n-103 callsubr\n-324 -12 rmoveto\n-99 callsubr\n60 hmoveto\n-99 callsubr\n132 hmoveto\n-53 callsubr\n36 hmoveto\n-7 callsubr\n-408 -12 rmoveto\n85 callsubr\n40 callsubr\n39 callsubr\n-30 callsubr\n48 hmoveto\n-99 callsubr\n-101 callsubr\n132 hmoveto\n-102 callsubr\n48 hmoveto\n-7 callsubr\n-444 -12 rmoveto\n62 callsubr\n-92 callsubr\n48 hmoveto\n39 callsubr\n-7 callsubr\n132 hmoveto\n16 callsubr\n36 hmoveto\n-7 callsubr\n-528 -12 rmoveto\n39 callsubr\n-92 callsubr\n16 callsubr\n96 hmoveto\n62 callsubr\n-102 callsubr\n156 hmoveto\n62 callsubr\n36 hmoveto\n16 callsubr\n-528 -12 rmoveto\n-30 callsubr\n-53 callsubr\n-30 callsubr\n16 callsubr\n108 hmoveto\n85 callsubr\n16 callsubr\n-30 callsubr\n168 hmoveto\n63 callsubr\n24 hmoveto\n16 callsubr\n-540 -12 rmoveto\n62 callsubr\n108 hmoveto\n-53 callsubr\n39 callsubr\n-94 callsubr\n-102 callsubr\n192 hmoveto\n39 callsubr\n24 hmoveto\n-30 callsubr\n-552 -12 rmoveto\n63 callsubr\n24 hmoveto\n-74 callsubr\n-95 callsubr\n39 callsubr\n-97 callsubr\n-102 callsubr\n216 hmoveto\n39 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-552 -12 rmoveto\n-91 callsubr\n16 callsubr\n348 hmoveto\n-30 callsubr\n12 hmoveto\n62 callsubr\n-552 -12 rmoveto\n-97 callsubr\n16 callsubr\n420 hmoveto\n-99 callsubr\n24 hmoveto\n-103 callsubr\n-552 -12 rmoveto\n-99 callsubr\n-102 callsubr\n456 hmoveto\n39 callsubr\n-101 callsubr\n12 hmoveto\n-30 callsubr\n-72 -12 rmoveto\n62 callsubr\n-102 callsubr\n12 hmoveto\n62 callsubr\n-60 -12 rmoveto\n-99 callsubr\n24 hmoveto\n-102 callsubr\n-60 -12 rmoveto\n-99 callsubr\n24 hmoveto\n85 callsubr\n-30 callsubr\n-96 -12 rmoveto\n39 callsubr\n-101 callsubr\n36 hmoveto\n62 callsubr\n-102 callsubr\n24 hmoveto\n-102 callsubr\n-144 -12 rmoveto\n62 callsubr\n-103 callsubr\n48 hmoveto\n42 callsubr\n-132 -12 rmoveto\n-98 callsubr\n-101 callsubr\n36 hmoveto\n62 callsubr\n-99 callsubr\n-120 -12 rmoveto\n39 callsubr\n-98 callsubr\n40 callsubr\n-101 callsubr\n",
        "initialPosition": {
            "x": 39,
            "y": 9
        },
        "endPosition": {
            "x": 52,
            "y": 56
        }
    },
    "Run0026.coderelay.png": {
        "commands":
        "-101 callsubr\n39 callsubr\n-99 callsubr\n16 callsubr\n-108 -12 rmoveto\n85 callsubr\n-6 callsubr\n39 callsubr\n-99 callsubr\n-120 -12 rmoveto\n39 callsubr\n-103 callsubr\n72 hmoveto\n-103 callsubr\n-132 -12 rmoveto\n-99 callsubr\n-102 callsubr\n72 hmoveto\n39 callsubr\n-156 -12 rmoveto\n85 callsubr\n-30 callsubr\n84 hmoveto\n-30 callsubr\n-180 -12 rmoveto\n62 callsubr\n-30 callsubr\n96 hmoveto\n62 callsubr\n-192 -12 rmoveto\n62 callsubr\n-99 callsubr\n120 hmoveto\n-30 callsubr\n-384 -12 rmoveto\n-101 callsubr\n156 hmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n108 hmoveto\n85 callsubr\n-102 callsubr\n-396 -12 rmoveto\n62 callsubr\n-98 callsubr\n108 hmoveto\n39 callsubr\n-99 callsubr\n16 callsubr\n108 hmoveto\n-99 callsubr\n-102 callsubr\n-384 -12 rmoveto\n-95 callsubr\n84 hmoveto\n39 callsubr\n-99 callsubr\n-101 callsubr\n120 hmoveto\n62 callsubr\n-102 callsubr\n-372 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-98 callsubr\n60 hmoveto\n39 callsubr\n-103 callsubr\n96 hmoveto\n16 callsubr\n36 hmoveto\n-7 callsubr\n-360 -12 rmoveto\n-98 callsubr\n-76 callsubr\n-98 callsubr\n-101 callsubr\n24 hmoveto\n39 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-94 callsubr\n-101 callsubr\n24 hmoveto\n-76 callsubr\n-348 -12 rmoveto\n62 callsubr\n-99 callsubr\n-75 callsubr\n-99 callsubr\n85 callsubr\n-102 callsubr\n24 hmoveto\n-97 callsubr\n96 hmoveto\n62 callsubr\n-312 -12 rmoveto\n-97 callsubr\n-76 callsubr\n-99 callsubr\n-101 callsubr\n12 hmoveto\n-98 callsubr\n-102 callsubr\n12 hmoveto\n-103 callsubr\n96 hmoveto\n-7 callsubr\n-300 -12 rmoveto\n-97 callsubr\n-76 callsubr\n24 hmoveto\n-99 callsubr\n-102 callsubr\n24 hmoveto\n39 callsubr\n84 hmoveto\n39 callsubr\n-276 -12 rmoveto\n-97 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n24 hmoveto\n-76 callsubr\n84 hmoveto\n40 callsubr\n-276 -12 rmoveto\n-99 callsubr\n-102 callsubr\n12 hmoveto\n-75 callsubr\n-99 callsubr\n-101 callsubr\n12 hmoveto\n-30 callsubr\n72 hmoveto\n-75 callsubr\n-103 callsubr\n-276 -12 rmoveto\n39 callsubr\n62 callsubr\n-30 callsubr\n39 callsubr\n-99 callsubr\n39 callsubr\n84 hmoveto\n-96 callsubr\n-102 callsubr\n-300 -12 rmoveto\n-98 callsubr\n39 callsubr\n-30 callsubr\n39 callsubr\n-99 callsubr\n-102 callsubr\n84 hmoveto\n-30 callsubr\n41 callsubr\n-99 callsubr\n16 callsubr\n-360 -12 rmoveto\n85 callsubr\n-102 callsubr\n24 hmoveto\n39 callsubr\n-99 callsubr\n39 callsubr\n-99 callsubr\n72 hmoveto\n85 callsubr\n24 hmoveto\n39 callsubr\n-96 callsubr\n-288 -12 rmoveto\n39 callsubr\n-99 callsubr\n39 callsubr\n-30 callsubr\n60 hmoveto\n-102 callsubr\n60 hmoveto\n42 callsubr\n-276 -12 rmoveto\n39 callsubr\n-99 callsubr\n39 callsubr\n-103 callsubr\n60 hmoveto\n-7 callsubr\n-156 -12 rmoveto\n-96 callsubr\n-101 callsubr\n60 hmoveto\n39 callsubr\n-156 -12 rmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n84 hmoveto\n-99 callsubr\n-156 -12 rmoveto\n-98 callsubr\n108 hmoveto\n-76 callsubr\n-168 -12 rmoveto\n39 callsubr\n-30 callsubr\n-101 callsubr\n96 hmoveto\n62 callsubr\n-102 callsubr\n-396 -12 rmoveto\n85 callsubr\n-99 callsubr\n-102 callsubr\n144 hmoveto\n-99 callsubr\n12 hmoveto\n-76 callsubr\n62 callsubr\n-102 callsubr\n72 hmoveto\n62 callsubr\n-432 -12 rmoveto\n85 callsubr\n-98 callsubr\n85 callsubr\n-30 callsubr\n120 hmoveto\n39 callsubr\n60 hmoveto\n-98 callsubr\n72 hmoveto\n62 callsubr\n-102 callsubr\n-480 -12 rmoveto\n62 callsubr\n-29 callsubr\n-101 callsubr\n36 hmoveto\n39 callsubr\n-30 callsubr\n-53 callsubr\n72 hmoveto\n-30 callsubr\n48 hmoveto\n-101 callsubr\n12 hmoveto\n-99 callsubr\n-102 callsubr\n72 hmoveto\n39 callsubr\n-101 callsubr\n-492 -12 rmoveto\n-30 callsubr\n108 hmoveto\n-95 callsubr\n-76 callsubr\n-101 callsubr\n12 hmoveto\n-103 callsubr\n48 hmoveto\n-30 callsubr\n24 hmoveto\n62 callsubr\n-99 callsubr\n60 hmoveto\n40 callsubr\n-504 -12 rmoveto\n-96 callsubr\n96 hmoveto\n39 callsubr\n-95 callsubr\n-101 callsubr\n48 hmoveto\n-30 callsubr\n48 hmoveto\n40 callsubr\n16 callsubr\n36 hmoveto\n-99 callsubr\n-102 callsubr\n-492 -12 rmoveto\n62 callsubr\n-99 callsubr\n-53 callsubr\n40 callsubr\n-101 callsubr\n48 hmoveto\n85 callsubr\n-97 callsubr\n36 hmoveto\n62 callsubr\n96 hmoveto\n-99 callsubr\n16 callsubr\n24 hmoveto\n39 callsubr\n-408 -12 rmoveto\n39 callsubr\n-99 callsubr\n-101 callsubr\n60 hmoveto\n-99 callsubr\n-101 callsubr\n36 hmoveto\n-7 callsubr\n108 hmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n62 callsubr\n-384 -12 rmoveto\n39 callsubr\n-99 callsubr\n-101 callsubr\n48 hmoveto\n-101 callsubr\n48 hmoveto\n-102 callsubr\n144 hmoveto\n-103 callsubr\n36 hmoveto\n-103 callsubr\n-360 -12 rmoveto\n62 callsubr\n-99 callsubr\n84 hmoveto\n-76 callsubr\n144 hmoveto\n-103 callsubr\n36 hmoveto\n-103 callsubr\n-336 -12 rmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n48 hmoveto\n-101 callsubr\n156 hmoveto\n-102 callsubr\n36 hmoveto\n-102 callsubr\n-324 -12 rmoveto\n62 callsubr\n-99 callsubr\n-75 callsubr\n-7 callsubr\n156 hmoveto\n-76 callsubr\n24 hmoveto\n-101 callsubr\n-300 -12 rmoveto\n62 callsubr\n-97 callsubr\n168 hmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n16 callsubr\n-276 -12 rmoveto\n39 callsubr\n192 hmoveto\n-99 callsubr\n85 callsubr\n-102 callsubr\n-60 -12 rmoveto\n40 callsubr\n12 hmoveto\n-7 callsubr\n-60 -12 rmoveto\n-30 callsubr\n12 hmoveto\n39 callsubr\n-60 -12 rmoveto\n-99 callsubr\n12 hmoveto\n62 callsubr\n-102 callsubr\n-72 -12 rmoveto\n39 callsubr\n24 hmoveto\n39 callsubr\n-101 callsubr\n-72 -12 rmoveto\n-101 callsubr\n36 hmoveto\n-76 callsubr\n-101 callsubr\n-84 -12 rmoveto\n-53 callsubr\n24 hmoveto\n85 callsubr\n-30 callsubr\n-96 -12 rmoveto\n-76 callsubr\n48 hmoveto\n39 callsubr\n-103 callsubr\n-108 -12 rmoveto\n39 callsubr\n60 hmoveto\n39 callsubr\n-30 callsubr\n-132 -12 rmoveto\n63 callsubr\n60 hmoveto\n39 callsubr\n-99 callsubr\n-132 -12 rmoveto\n39 callsubr\n-101 callsubr\n72 hmoveto\n39 callsubr\n-120 -12 rmoveto\n-97 callsubr\n-76 callsubr\n-30 callsubr\n-84 -12 rmoveto\n85 callsubr\n-98 callsubr\n-102 callsubr\n-24 -12 rmoveto\n-101 callsubr\n",
        "initialPosition": {
            "x": 39,
            "y": 9
        },
        "endPosition": {
            "x": 50,
            "y": 60
        }
    },
    "Run0027.coderelay.png": {
        "commands":
        "-101 callsubr\n-98 callsubr\n16 callsubr\n-96 -12 rmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n12 hmoveto\n39 callsubr\n-103 callsubr\n-120 -12 rmoveto\n-97 callsubr\n48 hmoveto\n85 callsubr\n-144 -12 rmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n60 hmoveto\n-30 callsubr\n-168 -12 rmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n72 hmoveto\n63 callsubr\n-180 -12 rmoveto\n39 callsubr\n-99 callsubr\n96 hmoveto\n39 callsubr\n-180 -12 rmoveto\n-98 callsubr\n-102 callsubr\n108 hmoveto\n-30 callsubr\n-192 -12 rmoveto\n39 callsubr\n-7 callsubr\n96 hmoveto\n62 callsubr\n-103 callsubr\n-192 -12 rmoveto\n62 callsubr\n16 callsubr\n96 hmoveto\n62 callsubr\n-30 callsubr\n-192 -12 rmoveto\n39 callsubr\n96 hmoveto\n85 callsubr\n-7 callsubr\n-180 -12 rmoveto\n62 callsubr\n-103 callsubr\n96 hmoveto\n39 callsubr\n-168 -12 rmoveto\n-98 callsubr\n36 hmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n39 callsubr\n-101 callsubr\n-180 -12 rmoveto\n62 callsubr\n-103 callsubr\n36 hmoveto\n39 callsubr\n-103 callsubr\n36 hmoveto\n-76 callsubr\n-168 -12 rmoveto\n-30 callsubr\n24 hmoveto\n62 callsubr\n-30 callsubr\n48 hmoveto\n-7 callsubr\n-180 -12 rmoveto\n-30 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n48 hmoveto\n62 callsubr\n-288 -12 rmoveto\n-30 callsubr\n84 hmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n-99 callsubr\n-102 callsubr\n72 hmoveto\n-30 callsubr\n-300 -12 rmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n60 hmoveto\n-30 callsubr\n12 hmoveto\n-99 callsubr\n-102 callsubr\n72 hmoveto\n63 callsubr\n-300 -12 rmoveto\n-95 callsubr\n-102 callsubr\n36 hmoveto\n-103 callsubr\n12 hmoveto\n62 callsubr\n-7 callsubr\n72 hmoveto\n-30 callsubr\n-288 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-95 callsubr\n24 hmoveto\n39 callsubr\n-101 callsubr\n72 hmoveto\n62 callsubr\n-276 -12 rmoveto\n-96 callsubr\n-76 callsubr\n-98 callsubr\n12 hmoveto\n-97 callsubr\n72 hmoveto\n-99 callsubr\n-264 -12 rmoveto\n39 callsubr\n-96 callsubr\n-102 callsubr\n24 hmoveto\n62 callsubr\n-7 callsubr\n72 hmoveto\n-30 callsubr\n-228 -12 rmoveto\n85 callsubr\n-98 callsubr\n24 hmoveto\n-76 callsubr\n-98 callsubr\n-102 callsubr\n48 hmoveto\n-30 callsubr\n-192 -12 rmoveto\n39 callsubr\n24 hmoveto\n-75 callsubr\n-96 callsubr\n-101 callsubr\n12 hmoveto\n-30 callsubr\n-192 -12 rmoveto\n-99 callsubr\n24 hmoveto\n-98 callsubr\n-75 callsubr\n-95 callsubr\n-336 -12 rmoveto\n-92 callsubr\n-102 callsubr\n24 hmoveto\n-99 callsubr\n-76 callsubr\n62 callsubr\n-94 callsubr\n12 hmoveto\n63 callsubr\n-348 -12 rmoveto\n-97 callsubr\n62 callsubr\n-99 callsubr\n62 callsubr\n24 hmoveto\n62 callsubr\n-7 callsubr\n39 callsubr\n-94 callsubr\n24 hmoveto\n62 callsubr\n-336 -12 rmoveto\n62 callsubr\n-98 callsubr\n-101 callsubr\n12 hmoveto\n-99 callsubr\n72 hmoveto\n-97 callsubr\n-102 callsubr\n12 hmoveto\n-99 callsubr\n-102 callsubr\n36 hmoveto\n62 callsubr\n-324 -12 rmoveto\n39 callsubr\n-99 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n36 hmoveto\n-103 callsubr\n12 hmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n60 hmoveto\n62 callsubr\n-102 callsubr\n-324 -12 rmoveto\n62 callsubr\n-103 callsubr\n36 hmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n12 hmoveto\n-103 callsubr\n36 hmoveto\n62 callsubr\n-103 callsubr\n72 hmoveto\n-99 callsubr\n-300 -12 rmoveto\n40 callsubr\n36 hmoveto\n39 callsubr\n-29 callsubr\n48 hmoveto\n39 callsubr\n-103 callsubr\n72 hmoveto\n-103 callsubr\n-288 -12 rmoveto\n40 callsubr\n48 hmoveto\n39 callsubr\n-103 callsubr\n48 hmoveto\n62 callsubr\n-99 callsubr\n60 hmoveto\n-53 callsubr\n-288 -12 rmoveto\n39 callsubr\n-103 callsubr\n48 hmoveto\n-99 callsubr\n48 hmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n60 hmoveto\n-101 callsubr\n-276 -12 rmoveto\n39 callsubr\n-103 callsubr\n108 hmoveto\n39 callsubr\n62 callsubr\n-7 callsubr\n48 hmoveto\n-76 callsubr\n-276 -12 rmoveto\n40 callsubr\n96 hmoveto\n-99 callsubr\n12 hmoveto\n39 callsubr\n-103 callsubr\n48 hmoveto\n39 callsubr\n-264 -12 rmoveto\n39 callsubr\n96 hmoveto\n-99 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n36 hmoveto\n16 callsubr\n-264 -12 rmoveto\n63 callsubr\n72 hmoveto\n-7 callsubr\n36 hmoveto\n39 callsubr\n-103 callsubr\n36 hmoveto\n16 callsubr\n-252 -12 rmoveto\n39 callsubr\n-7 callsubr\n48 hmoveto\n-103 callsubr\n60 hmoveto\n62 callsubr\n36 hmoveto\n85 callsubr\n-240 -12 rmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n12 hmoveto\n-99 callsubr\n72 hmoveto\n-103 callsubr\n36 hmoveto\n39 callsubr\n-216 -12 rmoveto\n39 callsubr\n-97 callsubr\n72 hmoveto\n-103 callsubr\n36 hmoveto\n-30 callsubr\n-204 -12 rmoveto\n85 callsubr\n-102 callsubr\n96 hmoveto\n-103 callsubr\n36 hmoveto\n-103 callsubr\n-60 -12 rmoveto\n-103 callsubr\n36 hmoveto\n-102 callsubr\n-60 -12 rmoveto\n-103 callsubr\n36 hmoveto\n-102 callsubr\n-60 -12 rmoveto\n-103 callsubr\n36 hmoveto\n-102 callsubr\n-60 -12 rmoveto\n-103 callsubr\n36 hmoveto\n-103 callsubr\n-60 -12 rmoveto\n-103 callsubr\n36 hmoveto\n-103 callsubr\n-60 -12 rmoveto\n-7 callsubr\n24 hmoveto\n-7 callsubr\n-72 -12 rmoveto\n-7 callsubr\n24 hmoveto\n-30 callsubr\n-72 -12 rmoveto\n16 callsubr\n24 hmoveto\n-99 callsubr\n-72 -12 rmoveto\n-99 callsubr\n24 hmoveto\n40 callsubr\n-84 -12 rmoveto\n-99 callsubr\n36 hmoveto\n-99 callsubr\n-102 callsubr\n-96 -12 rmoveto\n-99 callsubr\n36 hmoveto\n62 callsubr\n-30 callsubr\n-108 -12 rmoveto\n39 callsubr\n48 hmoveto\n62 callsubr\n-30 callsubr\n-108 -12 rmoveto\n39 callsubr\n-30 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-99 callsubr\n-108 -12 rmoveto\n62 callsubr\n-94 callsubr\n-96 -12 rmoveto\n-93 callsubr\n",
        "initialPosition": {
            "x": 39,
            "y": 9
        },
        "endPosition": {
            "x": 46,
            "y": 63
        }
    },
    "Run0028.coderelay.png": {
        "commands":
        "-103 callsubr\n-98 callsubr\n-101 callsubr\n-96 -12 rmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n12 hmoveto\n-99 callsubr\n-108 -12 rmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n24 hmoveto\n-99 callsubr\n-132 -12 rmoveto\n-97 callsubr\n-102 callsubr\n48 hmoveto\n39 callsubr\n-156 -12 rmoveto\n39 callsubr\n-99 callsubr\n16 callsubr\n60 hmoveto\n-99 callsubr\n-168 -12 rmoveto\n39 callsubr\n-30 callsubr\n96 hmoveto\n-30 callsubr\n-180 -12 rmoveto\n39 callsubr\n-103 callsubr\n120 hmoveto\n-30 callsubr\n-192 -12 rmoveto\n39 callsubr\n132 hmoveto\n-99 callsubr\n-192 -12 rmoveto\n39 callsubr\n-103 callsubr\n108 hmoveto\n62 callsubr\n-99 callsubr\n-192 -12 rmoveto\n-99 callsubr\n108 hmoveto\n-98 callsubr\n-101 callsubr\n-180 -12 rmoveto\n-30 callsubr\n96 hmoveto\n-98 callsubr\n-102 callsubr\n-180 -12 rmoveto\n63 callsubr\n48 hmoveto\n85 callsubr\n24 hmoveto\n-99 callsubr\n-102 callsubr\n-168 -12 rmoveto\n-99 callsubr\n48 hmoveto\n40 callsubr\n12 hmoveto\n62 callsubr\n-102 callsubr\n-156 -12 rmoveto\n-99 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n39 callsubr\n-144 -12 rmoveto\n-99 callsubr\n36 hmoveto\n-30 callsubr\n36 hmoveto\n-7 callsubr\n-156 -12 rmoveto\n62 callsubr\n-102 callsubr\n24 hmoveto\n39 callsubr\n36 hmoveto\n16 callsubr\n-144 -12 rmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n-7 callsubr\n24 hmoveto\n62 callsubr\n-132 -12 rmoveto\n-99 callsubr\n24 hmoveto\n16 callsubr\n36 hmoveto\n-7 callsubr\n-132 -12 rmoveto\n-99 callsubr\n12 hmoveto\n62 callsubr\n36 hmoveto\n39 callsubr\n-132 -12 rmoveto\n39 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n36 hmoveto\n-99 callsubr\n-228 -12 rmoveto\n39 callsubr\n-99 callsubr\n-101 callsubr\n36 hmoveto\n-99 callsubr\n24 hmoveto\n85 callsubr\n24 hmoveto\n62 callsubr\n-102 callsubr\n-228 -12 rmoveto\n-93 callsubr\n48 hmoveto\n-93 callsubr\n-101 callsubr\n-252 -12 rmoveto\n-30 callsubr\n-72 callsubr\n60 hmoveto\n-72 callsubr\n-99 callsubr\n-252 -12 rmoveto\n-30 callsubr\n-73 callsubr\n-101 callsubr\n60 hmoveto\n-72 callsubr\n-99 callsubr\n-288 -12 rmoveto\n39 callsubr\n-94 callsubr\n39 callsubr\n60 hmoveto\n39 callsubr\n-95 callsubr\n-288 -12 rmoveto\n-98 callsubr\n12 hmoveto\n-30 callsubr\n39 callsubr\n-103 callsubr\n12 hmoveto\n-7 callsubr\n36 hmoveto\n62 callsubr\n-95 callsubr\n-101 callsubr\n-288 -12 rmoveto\n-98 callsubr\n48 hmoveto\n39 callsubr\n-29 callsubr\n-101 callsubr\n12 hmoveto\n-53 callsubr\n24 hmoveto\n85 callsubr\n-99 callsubr\n-252 -12 rmoveto\n-76 callsubr\n-99 callsubr\n36 hmoveto\n-99 callsubr\n12 hmoveto\n-98 callsubr\n39 callsubr\n48 hmoveto\n39 callsubr\n-240 -12 rmoveto\n62 callsubr\n-99 callsubr\n24 hmoveto\n39 callsubr\n-103 callsubr\n12 hmoveto\n-97 callsubr\n-101 callsubr\n48 hmoveto\n-7 callsubr\n-240 -12 rmoveto\n85 callsubr\n-103 callsubr\n36 hmoveto\n-99 callsubr\n62 callsubr\n-99 callsubr\n-102 callsubr\n60 hmoveto\n39 callsubr\n-228 -12 rmoveto\n63 callsubr\n-102 callsubr\n12 hmoveto\n39 callsubr\n-96 callsubr\n72 hmoveto\n-99 callsubr\n-228 -12 rmoveto\n-101 callsubr\n12 hmoveto\n-76 callsubr\n12 hmoveto\n-97 callsubr\n40 callsubr\n60 hmoveto\n-99 callsubr\n-192 -12 rmoveto\n-30 callsubr\n12 hmoveto\n-98 callsubr\n12 hmoveto\n62 callsubr\n-102 callsubr\n60 hmoveto\n-7 callsubr\n-204 -12 rmoveto\n62 callsubr\n24 hmoveto\n-99 callsubr\n24 hmoveto\n62 callsubr\n60 hmoveto\n-53 callsubr\n-192 -12 rmoveto\n-7 callsubr\n72 hmoveto\n-99 callsubr\n48 hmoveto\n85 callsubr\n-192 -12 rmoveto\n-99 callsubr\n84 hmoveto\n-30 callsubr\n48 hmoveto\n-102 callsubr\n-192 -12 rmoveto\n-99 callsubr\n-101 callsubr\n72 hmoveto\n-99 callsubr\n36 hmoveto\n39 callsubr\n-180 -12 rmoveto\n40 callsubr\n60 hmoveto\n-99 callsubr\n36 hmoveto\n-30 callsubr\n-168 -12 rmoveto\n39 callsubr\n-30 callsubr\n-102 callsubr\n24 hmoveto\n-99 callsubr\n36 hmoveto\n-7 callsubr\n-144 -12 rmoveto\n62 callsubr\n-99 callsubr\n39 callsubr\n-103 callsubr\n24 hmoveto\n62 callsubr\n-108 -12 rmoveto\n85 callsubr\n-99 callsubr\n-101 callsubr\n24 hmoveto\n39 callsubr\n-72 -12 rmoveto\n-102 callsubr\n36 hmoveto\n-103 callsubr\n-60 -12 rmoveto\n-103 callsubr\n24 hmoveto\n-99 callsubr\n-72 -12 rmoveto\n39 callsubr\n24 hmoveto\n-30 callsubr\n-72 -12 rmoveto\n39 callsubr\n24 hmoveto\n-101 callsubr\n-60 -12 rmoveto\n-30 callsubr\n12 hmoveto\n-53 callsubr\n-72 -12 rmoveto\n62 callsubr\n24 hmoveto\n-53 callsubr\n-72 -12 rmoveto\n-99 callsubr\n24 hmoveto\n16 callsubr\n-72 -12 rmoveto\n-7 callsubr\n24 hmoveto\n-101 callsubr\n-72 -12 rmoveto\n85 callsubr\n36 hmoveto\n-101 callsubr\n-72 -12 rmoveto\n-101 callsubr\n48 hmoveto\n-102 callsubr\n-72 -12 rmoveto\n-102 callsubr\n48 hmoveto\n63 callsubr\n-102 callsubr\n-108 -12 rmoveto\n16 callsubr\n84 hmoveto\n-7 callsubr\n-132 -12 rmoveto\n39 callsubr\n-30 callsubr\n-75 callsubr\n-97 callsubr\n-132 -12 rmoveto\n39 callsubr\n-93 callsubr\n",
        "initialPosition": {
            "x": 40,
            "y": 9
        },
        "endPosition": {
            "x": 38,
            "y": 63
        }
    },
    "Run0029.coderelay.png": {
        "commands":
        "-101 callsubr\n39 callsubr\n-103 callsubr\n-72 -12 rmoveto\n62 callsubr\n-97 callsubr\n-102 callsubr\n-84 -12 rmoveto\n-98 callsubr\n24 hmoveto\n85 callsubr\n-96 -12 rmoveto\n39 callsubr\n-101 callsubr\n48 hmoveto\n-102 callsubr\n-132 -12 rmoveto\n85 callsubr\n-99 callsubr\n-102 callsubr\n60 hmoveto\n-7 callsubr\n-156 -12 rmoveto\n39 callsubr\n-30 callsubr\n72 hmoveto\n63 callsubr\n-180 -12 rmoveto\n62 callsubr\n16 callsubr\n96 hmoveto\n39 callsubr\n-192 -12 rmoveto\n62 callsubr\n-99 callsubr\n108 hmoveto\n62 callsubr\n-102 callsubr\n-204 -12 rmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n36 hmoveto\n-103 callsubr\n48 hmoveto\n62 callsubr\n-7 callsubr\n-228 -12 rmoveto\n62 callsubr\n-29 callsubr\n-7 callsubr\n24 hmoveto\n39 callsubr\n12 hmoveto\n39 callsubr\n-98 callsubr\n-102 callsubr\n-240 -12 rmoveto\n86 callsubr\n24 hmoveto\n-98 callsubr\n36 hmoveto\n-7 callsubr\n12 hmoveto\n-98 callsubr\n-76 callsubr\n-240 -12 rmoveto\n-76 callsubr\n-101 callsubr\n24 hmoveto\n62 callsubr\n39 callsubr\n24 hmoveto\n62 callsubr\n12 hmoveto\n39 callsubr\n-216 -12 rmoveto\n86 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-97 callsubr\n24 hmoveto\n-30 callsubr\n12 hmoveto\n-30 callsubr\n-216 -12 rmoveto\n-76 callsubr\n-101 callsubr\n12 hmoveto\n62 callsubr\n42 callsubr\n12 hmoveto\n39 callsubr\n12 hmoveto\n39 callsubr\n-216 -12 rmoveto\n86 callsubr\n12 hmoveto\n62 callsubr\n39 callsubr\n-5 callsubr\n12 hmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n-228 -12 rmoveto\n86 callsubr\n12 hmoveto\n62 callsubr\n-103 callsubr\n12 hmoveto\n-7 callsubr\n63 callsubr\n12 hmoveto\n-98 callsubr\n-102 callsubr\n-228 -12 rmoveto\n85 callsubr\n-30 callsubr\n-76 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n24 hmoveto\n-103 callsubr\n24 hmoveto\n-98 callsubr\n-228 -12 rmoveto\n85 callsubr\n-102 callsubr\n12 hmoveto\n-76 callsubr\n-101 callsubr\n24 hmoveto\n-99 callsubr\n24 hmoveto\n-103 callsubr\n24 hmoveto\n-30 callsubr\n-228 -12 rmoveto\n39 callsubr\n-101 callsubr\n12 hmoveto\n86 callsubr\n36 hmoveto\n-103 callsubr\n36 hmoveto\n-103 callsubr\n24 hmoveto\n-101 callsubr\n36 hmoveto\n39 callsubr\n-98 callsubr\n-324 -12 rmoveto\n-6 callsubr\n-30 callsubr\n-101 callsubr\n36 hmoveto\n-99 callsubr\n-102 callsubr\n36 hmoveto\n-103 callsubr\n24 hmoveto\n-102 callsubr\n12 hmoveto\n39 callsubr\n-96 callsubr\n-102 callsubr\n-336 -12 rmoveto\n-28 callsubr\n48 hmoveto\n-98 callsubr\n48 hmoveto\n-102 callsubr\n24 hmoveto\n-96 callsubr\n-76 callsubr\n-98 callsubr\n-240 -12 rmoveto\n-99 callsubr\n60 hmoveto\n-99 callsubr\n62 callsubr\n-99 callsubr\n-75 callsubr\n-97 callsubr\n-240 -12 rmoveto\n-103 callsubr\n36 hmoveto\n39 callsubr\n-98 callsubr\n24 hmoveto\n-76 callsubr\n-96 callsubr\n-102 callsubr\n-240 -12 rmoveto\n62 callsubr\n-95 callsubr\n-76 callsubr\n24 hmoveto\n-97 callsubr\n-102 callsubr\n-204 -12 rmoveto\n39 callsubr\n-97 callsubr\n-74 callsubr\n24 hmoveto\n-99 callsubr\n-168 -12 rmoveto\n-99 callsubr\n-72 callsubr\n-99 callsubr\n-102 callsubr\n12 hmoveto\n39 callsubr\n-103 callsubr\n-180 -12 rmoveto\n-99 callsubr\n-76 callsubr\n-90 callsubr\n-102 callsubr\n-192 -12 rmoveto\n39 callsubr\n-95 callsubr\n62 callsubr\n-98 callsubr\n12 hmoveto\n-98 callsubr\n-192 -12 rmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n-98 callsubr\n48 hmoveto\n-99 callsubr\n-101 callsubr\n-216 -12 rmoveto\n-29 callsubr\n60 hmoveto\n-98 callsubr\n-102 callsubr\n48 hmoveto\n-99 callsubr\n-102 callsubr\n-240 -12 rmoveto\n-99 callsubr\n12 hmoveto\n-103 callsubr\n60 hmoveto\n-53 callsubr\n84 hmoveto\n-99 callsubr\n-252 -12 rmoveto\n-99 callsubr\n-53 callsubr\n-103 callsubr\n60 hmoveto\n-103 callsubr\n96 hmoveto\n40 callsubr\n-264 -12 rmoveto\n-96 callsubr\n36 hmoveto\n-98 callsubr\n-101 callsubr\n60 hmoveto\n85 callsubr\n-98 callsubr\n-264 -12 rmoveto\n-76 callsubr\n85 callsubr\n-30 callsubr\n24 hmoveto\n39 callsubr\n-6 callsubr\n-97 callsubr\n39 callsubr\n-99 callsubr\n-101 callsubr\n-228 -12 rmoveto\n-30 callsubr\n-101 callsubr\n24 hmoveto\n63 callsubr\n-108 -12 rmoveto\n62 callsubr\n48 hmoveto\n-102 callsubr\n-84 -12 rmoveto\n-99 callsubr\n36 hmoveto\n39 callsubr\n-96 -12 rmoveto\n63 callsubr\n24 hmoveto\n63 callsubr\n-96 -12 rmoveto\n-76 callsubr\n36 hmoveto\n-7 callsubr\n-84 -12 rmoveto\n-103 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n-96 -12 rmoveto\n-76 callsubr\n36 hmoveto\n-30 callsubr\n-84 -12 rmoveto\n-101 callsubr\n36 hmoveto\n63 callsubr\n-96 -12 rmoveto\n-99 callsubr\n36 hmoveto\n39 callsubr\n-84 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-30 callsubr\n-84 -12 rmoveto\n-103 callsubr\n36 hmoveto\n85 callsubr\n-84 -12 rmoveto\n39 callsubr\n36 hmoveto\n39 callsubr\n-84 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-30 callsubr\n-96 -12 rmoveto\n39 callsubr\n36 hmoveto\n39 callsubr\n-96 -12 rmoveto\n63 callsubr\n36 hmoveto\n-7 callsubr\n-96 -12 rmoveto\n39 callsubr\n48 hmoveto\n-99 callsubr\n-96 -12 rmoveto\n-103 callsubr\n72 hmoveto\n-99 callsubr\n-101 callsubr\n-120 -12 rmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n62 callsubr\n-7 callsubr\n-132 -12 rmoveto\n63 callsubr\n40 callsubr\n24 hmoveto\n39 callsubr\n-103 callsubr\n-84 -12 rmoveto\n62 callsubr\n-7 callsubr\n12 hmoveto\n-99 callsubr\n-101 callsubr\n-72 -12 rmoveto\n39 callsubr\n-97 callsubr\n",
        "initialPosition": {
            "x": 40,
            "y": 8
        },
        "endPosition": {
            "x": 27,
            "y": 62
        }
    },
    "Run0030.coderelay.png": {
        "commands":
        "-101 callsubr\n-99 callsubr\n-102 callsubr\n-60 -12 rmoveto\n62 callsubr\n-97 callsubr\n-84 -12 rmoveto\n62 callsubr\n-103 callsubr\n36 hmoveto\n-30 callsubr\n-108 -12 rmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n-99 callsubr\n-120 -12 rmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n62 callsubr\n-103 callsubr\n-180 -12 rmoveto\n85 callsubr\n-97 callsubr\n-102 callsubr\n60 hmoveto\n39 callsubr\n-103 callsubr\n-252 -12 rmoveto\n87 callsubr\n-95 callsubr\n-101 callsubr\n84 hmoveto\n39 callsubr\n-252 -12 rmoveto\n39 callsubr\n-7 callsubr\n41 callsubr\n-101 callsubr\n120 hmoveto\n-99 callsubr\n-276 -12 rmoveto\n62 callsubr\n-103 callsubr\n60 hmoveto\n39 callsubr\n24 hmoveto\n-101 callsubr\n72 hmoveto\n39 callsubr\n-103 callsubr\n-288 -12 rmoveto\n62 callsubr\n-7 callsubr\n36 hmoveto\n62 callsubr\n-98 callsubr\n24 hmoveto\n-103 callsubr\n48 hmoveto\n-97 callsubr\n24 hmoveto\n39 callsubr\n-30 callsubr\n-360 -12 rmoveto\n40 callsubr\n24 hmoveto\n62 callsubr\n-95 callsubr\n24 hmoveto\n-99 callsubr\n36 hmoveto\n-103 callsubr\n48 hmoveto\n62 callsubr\n-97 callsubr\n-384 -12 rmoveto\n85 callsubr\n24 hmoveto\n-73 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n12 hmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n62 callsubr\n48 hmoveto\n-99 callsubr\n-76 callsubr\n-99 callsubr\n-420 -12 rmoveto\n-53 callsubr\n-30 callsubr\n85 callsubr\n-76 callsubr\n-101 callsubr\n48 hmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n12 hmoveto\n62 callsubr\n-103 callsubr\n12 hmoveto\n39 callsubr\n36 hmoveto\n39 callsubr\n-29 callsubr\n-30 callsubr\n-444 -12 rmoveto\n85 callsubr\n39 callsubr\n85 callsubr\n-30 callsubr\n-101 callsubr\n72 hmoveto\n-99 callsubr\n62 callsubr\n-102 callsubr\n24 hmoveto\n62 callsubr\n40 callsubr\n36 hmoveto\n-99 callsubr\n-76 callsubr\n-99 callsubr\n-444 -12 rmoveto\n62 callsubr\n-30 callsubr\n-76 callsubr\n-53 callsubr\n96 hmoveto\n-99 callsubr\n12 hmoveto\n-99 callsubr\n36 hmoveto\n-98 callsubr\n48 hmoveto\n-99 callsubr\n-76 callsubr\n-30 callsubr\n-432 -12 rmoveto\n62 callsubr\n144 hmoveto\n63 callsubr\n12 hmoveto\n62 callsubr\n-102 callsubr\n24 hmoveto\n62 callsubr\n-99 callsubr\n36 hmoveto\n-99 callsubr\n39 callsubr\n-103 callsubr\n-252 -12 rmoveto\n39 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n62 callsubr\n-99 callsubr\n24 hmoveto\n-30 callsubr\n39 callsubr\n-103 callsubr\n-264 -12 rmoveto\n62 callsubr\n-102 callsubr\n48 hmoveto\n-99 callsubr\n-102 callsubr\n36 hmoveto\n-96 callsubr\n39 callsubr\n-30 callsubr\n-264 -12 rmoveto\n-99 callsubr\n60 hmoveto\n62 callsubr\n-98 callsubr\n-102 callsubr\n12 hmoveto\n-98 callsubr\n-76 callsubr\n-99 callsubr\n-101 callsubr\n-264 -12 rmoveto\n-99 callsubr\n72 hmoveto\n40 callsubr\n39 callsubr\n-103 callsubr\n60 hmoveto\n62 callsubr\n-276 -12 rmoveto\n-99 callsubr\n-102 callsubr\n72 hmoveto\n39 callsubr\n48 hmoveto\n-98 callsubr\n-102 callsubr\n36 hmoveto\n-7 callsubr\n-300 -12 rmoveto\n40 callsubr\n84 hmoveto\n-99 callsubr\n48 hmoveto\n-98 callsubr\n39 callsubr\n-97 callsubr\n-300 -12 rmoveto\n-99 callsubr\n-101 callsubr\n84 hmoveto\n-99 callsubr\n-76 callsubr\n24 hmoveto\n-99 callsubr\n-76 callsubr\n-99 callsubr\n12 hmoveto\n-7 callsubr\n-300 -12 rmoveto\n-99 callsubr\n84 hmoveto\n39 callsubr\n85 callsubr\n-96 callsubr\n39 callsubr\n-99 callsubr\n-264 -12 rmoveto\n-99 callsubr\n72 hmoveto\n63 callsubr\n48 hmoveto\n-99 callsubr\n-76 callsubr\n-99 callsubr\n-102 callsubr\n-276 -12 rmoveto\n62 callsubr\n-102 callsubr\n72 hmoveto\n62 callsubr\n48 hmoveto\n39 callsubr\n-29 callsubr\n-99 callsubr\n-102 callsubr\n-276 -12 rmoveto\n-99 callsubr\n72 hmoveto\n62 callsubr\n-102 callsubr\n48 hmoveto\n-94 callsubr\n-102 callsubr\n-276 -12 rmoveto\n-99 callsubr\n60 hmoveto\n39 callsubr\n-103 callsubr\n60 hmoveto\n-93 callsubr\n-288 -12 rmoveto\n63 callsubr\n60 hmoveto\n-96 callsubr\n-102 callsubr\n36 hmoveto\n-98 callsubr\n-102 callsubr\n12 hmoveto\n62 callsubr\n-103 callsubr\n-300 -12 rmoveto\n-30 callsubr\n72 hmoveto\n-27 callsubr\n-98 callsubr\n24 hmoveto\n39 callsubr\n36 hmoveto\n16 callsubr\n-300 -12 rmoveto\n-103 callsubr\n72 hmoveto\n-76 callsubr\n36 hmoveto\n39 callsubr\n-99 callsubr\n72 hmoveto\n85 callsubr\n-300 -12 rmoveto\n-99 callsubr\n72 hmoveto\n-7 callsubr\n24 hmoveto\n39 callsubr\n-99 callsubr\n72 hmoveto\n-99 callsubr\n-101 callsubr\n-312 -12 rmoveto\n62 callsubr\n-102 callsubr\n48 hmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n39 callsubr\n-30 callsubr\n72 hmoveto\n-99 callsubr\n-101 callsubr\n-300 -12 rmoveto\n39 callsubr\n60 hmoveto\n-99 callsubr\n24 hmoveto\n39 callsubr\n-7 callsubr\n48 hmoveto\n62 callsubr\n-102 callsubr\n-276 -12 rmoveto\n63 callsubr\n48 hmoveto\n39 callsubr\n24 hmoveto\n39 callsubr\n-7 callsubr\n48 hmoveto\n-76 callsubr\n-101 callsubr\n-264 -12 rmoveto\n-76 callsubr\n36 hmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n24 hmoveto\n85 callsubr\n-102 callsubr\n-252 -12 rmoveto\n85 callsubr\n-102 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n24 hmoveto\n39 callsubr\n-101 callsubr\n-240 -12 rmoveto\n39 callsubr\n48 hmoveto\n-103 callsubr\n48 hmoveto\n-103 callsubr\n48 hmoveto\n85 callsubr\n-228 -12 rmoveto\n39 callsubr\n-101 callsubr\n36 hmoveto\n-101 callsubr\n60 hmoveto\n-76 callsubr\n36 hmoveto\n-30 callsubr\n-228 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-99 callsubr\n60 hmoveto\n85 callsubr\n36 hmoveto\n-103 callsubr\n-228 -12 rmoveto\n62 callsubr\n36 hmoveto\n62 callsubr\n84 hmoveto\n-102 callsubr\n24 hmoveto\n39 callsubr\n-228 -12 rmoveto\n39 callsubr\n36 hmoveto\n-103 callsubr\n96 hmoveto\n-99 callsubr\n12 hmoveto\n-30 callsubr\n-228 -12 rmoveto\n-30 callsubr\n24 hmoveto\n-30 callsubr\n96 hmoveto\n39 callsubr\n63 callsubr\n-240 -12 rmoveto\n62 callsubr\n24 hmoveto\n85 callsubr\n120 hmoveto\n-98 callsubr\n-228 -12 rmoveto\n-7 callsubr\n12 hmoveto\n85 callsubr\n156 hmoveto\n-103 callsubr\n-252 -12 rmoveto\n62 callsubr\n-103 callsubr\n12 hmoveto\n-53 callsubr\n-72 -12 rmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n16 callsubr\n-84 -12 rmoveto\n40 callsubr\n24 hmoveto\n-102 callsubr\n-72 -12 rmoveto\n-99 callsubr\n-24 -12 rmoveto\n-102 callsubr\n48 hmoveto\n-102 callsubr\n-72 -12 rmoveto\n-53 callsubr\n24 hmoveto\n-76 callsubr\n-72 -12 rmoveto\n62 callsubr\n24 hmoveto\n-30 callsubr\n-60 -12 rmoveto\n-30 callsubr\n12 hmoveto\n-7 callsubr\n-60 -12 rmoveto\n64 callsubr\n-103 callsubr\n-48 -12 rmoveto\n-30 callsubr\n40 callsubr\n-60 -12 rmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n",
        "initialPosition": {
            "x": 40,
            "y": 8
        },
        "endPosition": {
            "x": 16,
            "y": 63
        }
    },
    "Run0031.coderelay.png": {
        "commands":
        "-103 callsubr\n-101 callsubr\n-60 -12 rmoveto\n62 callsubr\n-98 callsubr\n-101 callsubr\n-84 -12 rmoveto\n-76 callsubr\n-101 callsubr\n24 hmoveto\n62 callsubr\n-102 callsubr\n-108 -12 rmoveto\n-99 callsubr\n-101 callsubr\n48 hmoveto\n-76 callsubr\n-132 -12 rmoveto\n-76 callsubr\n-30 callsubr\n60 hmoveto\n16 callsubr\n-168 -12 rmoveto\n-76 callsubr\n-99 callsubr\n16 callsubr\n72 hmoveto\n-102 callsubr\n-228 -12 rmoveto\n-76 callsubr\n-99 callsubr\n39 callsubr\n-28 callsubr\n60 hmoveto\n-96 callsubr\n-276 -12 rmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n156 hmoveto\n-99 callsubr\n-76 callsubr\n-103 callsubr\n-288 -12 rmoveto\n39 callsubr\n-7 callsubr\n180 hmoveto\n62 callsubr\n-76 callsubr\n-103 callsubr\n-300 -12 rmoveto\n40 callsubr\n24 hmoveto\n86 callsubr\n108 hmoveto\n62 callsubr\n-97 callsubr\n39 callsubr\n-101 callsubr\n-336 -12 rmoveto\n40 callsubr\n36 hmoveto\n-75 callsubr\n-30 callsubr\n84 hmoveto\n-98 callsubr\n-76 callsubr\n-99 callsubr\n40 callsubr\n-348 -12 rmoveto\n63 callsubr\n24 hmoveto\n-53 callsubr\n24 hmoveto\n39 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n39 callsubr\n36 hmoveto\n39 callsubr\n-29 callsubr\n-103 callsubr\n-360 -12 rmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n-101 callsubr\n48 hmoveto\n-76 callsubr\n36 hmoveto\n-102 callsubr\n36 hmoveto\n-99 callsubr\n36 hmoveto\n39 callsubr\n-29 callsubr\n-103 callsubr\n-384 -12 rmoveto\n85 callsubr\n-103 callsubr\n12 hmoveto\n-30 callsubr\n-101 callsubr\n48 hmoveto\n63 callsubr\n36 hmoveto\n-103 callsubr\n36 hmoveto\n-99 callsubr\n40 callsubr\n62 callsubr\n-29 callsubr\n-7 callsubr\n-396 -12 rmoveto\n-76 callsubr\n85 callsubr\n-102 callsubr\n72 hmoveto\n39 callsubr\n48 hmoveto\n-103 callsubr\n36 hmoveto\n-53 callsubr\n12 hmoveto\n-96 callsubr\n39 callsubr\n12 hmoveto\n-103 callsubr\n-396 -12 rmoveto\n-101 callsubr\n12 hmoveto\n-101 callsubr\n96 hmoveto\n-101 callsubr\n60 hmoveto\n39 callsubr\n-103 callsubr\n72 hmoveto\n85 callsubr\n48 hmoveto\n-103 callsubr\n-276 -12 rmoveto\n-53 callsubr\n72 hmoveto\n-99 callsubr\n-102 callsubr\n120 hmoveto\n63 callsubr\n-288 -12 rmoveto\n-7 callsubr\n72 hmoveto\n39 callsubr\n-97 callsubr\n-53 callsubr\n60 hmoveto\n-99 callsubr\n-101 callsubr\n-300 -12 rmoveto\n39 callsubr\n84 hmoveto\n-99 callsubr\n24 hmoveto\n-76 callsubr\n-98 callsubr\n40 callsubr\n40 callsubr\n-324 -12 rmoveto\n62 callsubr\n-99 callsubr\n84 hmoveto\n63 callsubr\n96 hmoveto\n-30 callsubr\n40 callsubr\n-324 -12 rmoveto\n-99 callsubr\n-101 callsubr\n96 hmoveto\n-99 callsubr\n108 hmoveto\n-30 callsubr\n39 callsubr\n-103 callsubr\n-336 -12 rmoveto\n-99 callsubr\n-102 callsubr\n108 hmoveto\n-99 callsubr\n108 hmoveto\n-99 callsubr\n39 callsubr\n-103 callsubr\n-336 -12 rmoveto\n-99 callsubr\n108 hmoveto\n-76 callsubr\n62 callsubr\n16 callsubr\n72 hmoveto\n-99 callsubr\n39 callsubr\n-103 callsubr\n-336 -12 rmoveto\n-7 callsubr\n96 hmoveto\n-7 callsubr\n24 hmoveto\n-97 callsubr\n60 hmoveto\n-99 callsubr\n-76 callsubr\n-103 callsubr\n-336 -12 rmoveto\n-30 callsubr\n84 hmoveto\n-30 callsubr\n48 hmoveto\n62 callsubr\n-7 callsubr\n48 hmoveto\n40 callsubr\n39 callsubr\n-348 -12 rmoveto\n40 callsubr\n72 hmoveto\n39 callsubr\n84 hmoveto\n85 callsubr\n-7 callsubr\n36 hmoveto\n-97 callsubr\n-360 -12 rmoveto\n62 callsubr\n-103 callsubr\n72 hmoveto\n39 callsubr\n-101 callsubr\n108 hmoveto\n62 callsubr\n36 hmoveto\n-98 callsubr\n-101 callsubr\n-360 -12 rmoveto\n-99 callsubr\n72 hmoveto\n62 callsubr\n-98 callsubr\n-102 callsubr\n96 hmoveto\n-29 callsubr\n-312 -12 rmoveto\n39 callsubr\n84 hmoveto\n-7 callsubr\n62 callsubr\n-98 callsubr\n-76 callsubr\n72 hmoveto\n-76 callsubr\n-312 -12 rmoveto\n-30 callsubr\n72 hmoveto\n16 callsubr\n48 hmoveto\n-76 callsubr\n-97 callsubr\n48 hmoveto\n-30 callsubr\n-324 -12 rmoveto\n39 callsubr\n72 hmoveto\n-30 callsubr\n120 hmoveto\n-30 callsubr\n36 hmoveto\n-102 callsubr\n-324 -12 rmoveto\n-99 callsubr\n-101 callsubr\n60 hmoveto\n-53 callsubr\n120 hmoveto\n62 callsubr\n36 hmoveto\n-99 callsubr\n-336 -12 rmoveto\n39 callsubr\n-103 callsubr\n60 hmoveto\n-53 callsubr\n132 hmoveto\n85 callsubr\n36 hmoveto\n-30 callsubr\n-360 -12 rmoveto\n62 callsubr\n-99 callsubr\n60 hmoveto\n-76 callsubr\n144 hmoveto\n-30 callsubr\n24 hmoveto\n39 callsubr\n-101 callsubr\n-384 -12 rmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n48 hmoveto\n62 callsubr\n-102 callsubr\n144 hmoveto\n40 callsubr\n24 hmoveto\n39 callsubr\n-372 -12 rmoveto\n-99 callsubr\n-101 callsubr\n60 hmoveto\n62 callsubr\n-102 callsubr\n156 hmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n-30 callsubr\n-384 -12 rmoveto\n62 callsubr\n72 hmoveto\n-75 callsubr\n168 hmoveto\n39 callsubr\n24 hmoveto\n63 callsubr\n-384 -12 rmoveto\n-30 callsubr\n60 hmoveto\n-30 callsubr\n-101 callsubr\n180 hmoveto\n62 callsubr\n24 hmoveto\n39 callsubr\n-384 -12 rmoveto\n-99 callsubr\n60 hmoveto\n85 callsubr\n204 hmoveto\n-99 callsubr\n24 hmoveto\n39 callsubr\n-396 -12 rmoveto\n-98 callsubr\n36 hmoveto\n85 callsubr\n228 hmoveto\n-30 callsubr\n24 hmoveto\n-99 callsubr\n-408 -12 rmoveto\n62 callsubr\n-102 callsubr\n36 hmoveto\n40 callsubr\n228 hmoveto\n-30 callsubr\n24 hmoveto\n-103 callsubr\n-408 -12 rmoveto\n62 callsubr\n-103 callsubr\n36 hmoveto\n62 callsubr\n-102 callsubr\n228 hmoveto\n62 callsubr\n-102 callsubr\n24 hmoveto\n-30 callsubr\n-432 -12 rmoveto\n62 callsubr\n-103 callsubr\n48 hmoveto\n-102 callsubr\n252 hmoveto\n39 callsubr\n36 hmoveto\n-99 callsubr\n-432 -12 rmoveto\n-99 callsubr\n36 hmoveto\n86 callsubr\n252 hmoveto\n-99 callsubr\n36 hmoveto\n39 callsubr\n-103 callsubr\n-456 -12 rmoveto\n63 callsubr\n36 hmoveto\n39 callsubr\n264 hmoveto\n-96 callsubr\n85 callsubr\n-7 callsubr\n-468 -12 rmoveto\n39 callsubr\n36 hmoveto\n62 callsubr\n312 hmoveto\n39 callsubr\n-97 callsubr\n-468 -12 rmoveto\n-76 callsubr\n36 hmoveto\n-7 callsubr\n348 hmoveto\n39 callsubr\n-99 callsubr\n-480 -12 rmoveto\n16 callsubr\n36 hmoveto\n-103 callsubr\n384 hmoveto\n85 callsubr\n-480 -12 rmoveto\n87 callsubr\n39 callsubr\n-53 callsubr\n",
        "initialPosition": {
            "x": 43,
            "y": 7
        },
        "endPosition": {
            "x": 11,
            "y": 55
        }
    },
    "Run0032.coderelay.png": {
        "commands":
        "-103 callsubr\n-97 callsubr\n-84 -12 rmoveto\n39 callsubr\n-30 callsubr\n-76 callsubr\n-30 callsubr\n-108 -12 rmoveto\n62 callsubr\n-7 callsubr\n36 hmoveto\n85 callsubr\n-120 -12 rmoveto\n39 callsubr\n-7 callsubr\n60 hmoveto\n-103 callsubr\n-156 -12 rmoveto\n-96 callsubr\n72 hmoveto\n62 callsubr\n-192 -12 rmoveto\n39 callsubr\n-98 callsubr\n16 callsubr\n84 hmoveto\n-7 callsubr\n-228 -12 rmoveto\n62 callsubr\n-98 callsubr\n120 hmoveto\n85 callsubr\n-103 callsubr\n-240 -12 rmoveto\n-101 callsubr\n12 hmoveto\n-97 callsubr\n-101 callsubr\n108 hmoveto\n62 callsubr\n-30 callsubr\n-264 -12 rmoveto\n39 callsubr\n-101 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n72 hmoveto\n-53 callsubr\n-97 callsubr\n-264 -12 rmoveto\n39 callsubr\n60 hmoveto\n-30 callsubr\n72 hmoveto\n62 callsubr\n-99 callsubr\n-101 callsubr\n-252 -12 rmoveto\n-7 callsubr\n24 hmoveto\n-53 callsubr\n-98 callsubr\n-101 callsubr\n12 hmoveto\n-53 callsubr\n36 hmoveto\n-99 callsubr\n-228 -12 rmoveto\n-103 callsubr\n36 hmoveto\n39 callsubr\n-6 callsubr\n-103 callsubr\n24 hmoveto\n-103 callsubr\n36 hmoveto\n39 callsubr\n-103 callsubr\n72 hmoveto\n62 callsubr\n16 callsubr\n-372 -12 rmoveto\n40 callsubr\n24 hmoveto\n40 callsubr\n12 hmoveto\n63 callsubr\n24 hmoveto\n-102 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n60 hmoveto\n62 callsubr\n-98 callsubr\n-101 callsubr\n-396 -12 rmoveto\n39 callsubr\n-101 callsubr\n12 hmoveto\n62 callsubr\n16 callsubr\n24 hmoveto\n-30 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n-99 callsubr\n72 hmoveto\n-98 callsubr\n39 callsubr\n-103 callsubr\n-408 -12 rmoveto\n39 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-101 callsubr\n48 hmoveto\n-103 callsubr\n48 hmoveto\n-101 callsubr\n36 hmoveto\n-99 callsubr\n60 hmoveto\n39 callsubr\n-29 callsubr\n-30 callsubr\n-420 -12 rmoveto\n62 callsubr\n12 hmoveto\n-30 callsubr\n-101 callsubr\n48 hmoveto\n85 callsubr\n-103 callsubr\n48 hmoveto\n-102 callsubr\n36 hmoveto\n40 callsubr\n36 hmoveto\n62 callsubr\n-30 callsubr\n39 callsubr\n-103 callsubr\n-408 -12 rmoveto\n39 callsubr\n85 callsubr\n60 hmoveto\n62 callsubr\n72 hmoveto\n-7 callsubr\n36 hmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n-99 callsubr\n-76 callsubr\n-99 callsubr\n-102 callsubr\n-396 -12 rmoveto\n-102 callsubr\n72 hmoveto\n62 callsubr\n-102 callsubr\n72 hmoveto\n40 callsubr\n36 hmoveto\n-99 callsubr\n-102 callsubr\n12 hmoveto\n-99 callsubr\n39 callsubr\n-99 callsubr\n-300 -12 rmoveto\n-99 callsubr\n96 hmoveto\n-99 callsubr\n-102 callsubr\n36 hmoveto\n-97 callsubr\n-76 callsubr\n-99 callsubr\n-101 callsubr\n-324 -12 rmoveto\n39 callsubr\n-103 callsubr\n96 hmoveto\n39 callsubr\n-98 callsubr\n24 hmoveto\n85 callsubr\n-99 callsubr\n39 callsubr\n-7 callsubr\n-312 -12 rmoveto\n-30 callsubr\n-101 callsubr\n84 hmoveto\n62 callsubr\n-102 callsubr\n12 hmoveto\n39 callsubr\n-103 callsubr\n60 hmoveto\n39 callsubr\n-288 -12 rmoveto\n-7 callsubr\n96 hmoveto\n40 callsubr\n24 hmoveto\n39 callsubr\n-103 callsubr\n60 hmoveto\n-30 callsubr\n-300 -12 rmoveto\n-7 callsubr\n72 hmoveto\n87 callsubr\n-7 callsubr\n24 hmoveto\n-98 callsubr\n-102 callsubr\n36 hmoveto\n-99 callsubr\n-312 -12 rmoveto\n62 callsubr\n-102 callsubr\n72 hmoveto\n-30 callsubr\n24 hmoveto\n-75 callsubr\n62 callsubr\n-99 callsubr\n39 callsubr\n-98 callsubr\n-102 callsubr\n-312 -12 rmoveto\n40 callsubr\n60 hmoveto\n39 callsubr\n60 hmoveto\n-97 callsubr\n39 callsubr\n-103 callsubr\n12 hmoveto\n-99 callsubr\n-102 callsubr\n-312 -12 rmoveto\n-99 callsubr\n72 hmoveto\n-7 callsubr\n60 hmoveto\n62 callsubr\n-29 callsubr\n-99 callsubr\n-276 -12 rmoveto\n39 callsubr\n-101 callsubr\n60 hmoveto\n40 callsubr\n60 hmoveto\n-98 callsubr\n39 callsubr\n-7 callsubr\n-276 -12 rmoveto\n-30 callsubr\n72 hmoveto\n39 callsubr\n-99 callsubr\n48 hmoveto\n-98 callsubr\n40 callsubr\n-276 -12 rmoveto\n39 callsubr\n72 hmoveto\n40 callsubr\n39 callsubr\n-30 callsubr\n24 hmoveto\n-96 callsubr\n-76 callsubr\n-288 -12 rmoveto\n-7 callsubr\n72 hmoveto\n16 callsubr\n24 hmoveto\n85 callsubr\n-99 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-7 callsubr\n12 hmoveto\n16 callsubr\n-300 -12 rmoveto\n-103 callsubr\n60 hmoveto\n63 callsubr\n60 hmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n48 hmoveto\n-30 callsubr\n-384 -12 rmoveto\n62 callsubr\n-95 callsubr\n48 hmoveto\n63 callsubr\n108 hmoveto\n39 callsubr\n48 hmoveto\n16 callsubr\n-492 -12 rmoveto\n62 callsubr\n-99 callsubr\n39 callsubr\n85 callsubr\n-30 callsubr\n12 hmoveto\n85 callsubr\n-76 callsubr\n60 hmoveto\n-76 callsubr\n-101 callsubr\n132 hmoveto\n85 callsubr\n36 hmoveto\n16 callsubr\n-504 -12 rmoveto\n85 callsubr\n17 callsubr\n39 callsubr\n-101 callsubr\n144 hmoveto\n-30 callsubr\n-101 callsubr\n156 hmoveto\n-102 callsubr\n36 hmoveto\n16 callsubr\n-504 -12 rmoveto\n-102 callsubr\n216 hmoveto\n-99 callsubr\n180 hmoveto\n-53 callsubr\n24 hmoveto\n-99 callsubr\n-516 -12 rmoveto\n-102 callsubr\n156 hmoveto\n62 callsubr\n-102 callsubr\n12 hmoveto\n62 callsubr\n-102 callsubr\n192 hmoveto\n62 callsubr\n24 hmoveto\n-99 callsubr\n-516 -12 rmoveto\n-101 callsubr\n24 hmoveto\n85 callsubr\n40 callsubr\n64 callsubr\n-76 callsubr\n-99 callsubr\n16 callsubr\n-30 callsubr\n216 hmoveto\n-102 callsubr\n36 hmoveto\n-76 callsubr\n-528 -12 rmoveto\n-74 callsubr\n-101 callsubr\n396 hmoveto\n-7 callsubr\n24 hmoveto\n85 callsubr\n-528 -12 rmoveto\n-53 callsubr\n432 hmoveto\n40 callsubr\n12 hmoveto\n62 callsubr\n-60 -12 rmoveto\n-99 callsubr\n24 hmoveto\n-103 callsubr\n-60 -12 rmoveto\n39 callsubr\n24 hmoveto\n-76 callsubr\n-60 -12 rmoveto\n-7 callsubr\n12 hmoveto\n62 callsubr\n-60 -12 rmoveto\n-7 callsubr\n12 hmoveto\n63 callsubr\n-72 -12 rmoveto\n-99 callsubr\n24 hmoveto\n63 callsubr\n-84 -12 rmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n-99 callsubr\n12 hmoveto\n-76 callsubr\n-108 -12 rmoveto\n-99 callsubr\n24 hmoveto\n85 callsubr\n39 callsubr\n-7 callsubr\n-120 -12 rmoveto\n-99 callsubr\n62 callsubr\n-95 callsubr\n-102 callsubr\n-96 -12 rmoveto\n85 callsubr\n24 hmoveto\n-99 callsubr\n16 callsubr\n",
        "initialPosition": {
            "x": 40,
            "y": 8
        },
        "endPosition": {
            "x": 51,
            "y": 55
        }
    },
    "Run0033.coderelay.png": {
        "commands":
        "-103 callsubr\n-98 callsubr\n-101 callsubr\n-72 -12 rmoveto\n-99 callsubr\n85 callsubr\n-98 callsubr\n-108 -12 rmoveto\n85 callsubr\n-7 callsubr\n48 hmoveto\n-103 callsubr\n-120 -12 rmoveto\n39 callsubr\n-30 callsubr\n60 hmoveto\n-102 callsubr\n-144 -12 rmoveto\n39 callsubr\n-99 callsubr\n-101 callsubr\n60 hmoveto\n39 callsubr\n-180 -12 rmoveto\n39 callsubr\n-98 callsubr\n-102 callsubr\n84 hmoveto\n-30 callsubr\n-192 -12 rmoveto\n39 callsubr\n-30 callsubr\n-101 callsubr\n96 hmoveto\n-30 callsubr\n-192 -12 rmoveto\n62 callsubr\n-102 callsubr\n132 hmoveto\n-7 callsubr\n-216 -12 rmoveto\n85 callsubr\n-99 callsubr\n96 hmoveto\n39 callsubr\n-99 callsubr\n-102 callsubr\n-228 -12 rmoveto\n39 callsubr\n-98 callsubr\n-101 callsubr\n84 hmoveto\n-97 callsubr\n-102 callsubr\n-228 -12 rmoveto\n62 callsubr\n-99 callsubr\n39 callsubr\n24 hmoveto\n-101 callsubr\n48 hmoveto\n-99 callsubr\n-192 -12 rmoveto\n-76 callsubr\n24 hmoveto\n62 callsubr\n-102 callsubr\n12 hmoveto\n85 callsubr\n36 hmoveto\n-98 callsubr\n-204 -12 rmoveto\n63 callsubr\n12 hmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n-76 callsubr\n36 hmoveto\n-99 callsubr\n-204 -12 rmoveto\n62 callsubr\n-102 callsubr\n12 hmoveto\n-98 callsubr\n-102 callsubr\n24 hmoveto\n39 callsubr\n24 hmoveto\n-99 callsubr\n-102 callsubr\n-204 -12 rmoveto\n-99 callsubr\n12 hmoveto\n39 callsubr\n63 callsubr\n24 hmoveto\n-99 callsubr\n24 hmoveto\n-99 callsubr\n-204 -12 rmoveto\n39 callsubr\n12 hmoveto\n39 callsubr\n62 callsubr\n-102 callsubr\n36 hmoveto\n-99 callsubr\n24 hmoveto\n-30 callsubr\n-216 -12 rmoveto\n39 callsubr\n24 hmoveto\n-97 callsubr\n-101 callsubr\n36 hmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n-7 callsubr\n-228 -12 rmoveto\n-98 callsubr\n85 callsubr\n39 callsubr\n-7 callsubr\n48 hmoveto\n-99 callsubr\n-102 callsubr\n12 hmoveto\n-99 callsubr\n-240 -12 rmoveto\n39 callsubr\n-99 callsubr\n16 callsubr\n63 callsubr\n60 hmoveto\n-99 callsubr\n-102 callsubr\n12 hmoveto\n-76 callsubr\n-228 -12 rmoveto\n-99 callsubr\n-102 callsubr\n12 hmoveto\n-99 callsubr\n-101 callsubr\n72 hmoveto\n39 callsubr\n-103 callsubr\n12 hmoveto\n-76 callsubr\n-192 -12 rmoveto\n-99 callsubr\n-101 callsubr\n72 hmoveto\n-101 callsubr\n12 hmoveto\n39 callsubr\n24 hmoveto\n-101 callsubr\n-192 -12 rmoveto\n-30 callsubr\n84 hmoveto\n-101 callsubr\n12 hmoveto\n40 callsubr\n12 hmoveto\n-30 callsubr\n84 hmoveto\n85 callsubr\n-7 callsubr\n-336 -12 rmoveto\n-99 callsubr\n72 hmoveto\n16 callsubr\n12 hmoveto\n62 callsubr\n-103 callsubr\n12 hmoveto\n-98 callsubr\n-76 callsubr\n-93 callsubr\n-324 -12 rmoveto\n-99 callsubr\n48 hmoveto\n85 callsubr\n24 hmoveto\n62 callsubr\n-103 callsubr\n24 hmoveto\n-92 callsubr\n-76 callsubr\n-103 callsubr\n-336 -12 rmoveto\n39 callsubr\n-103 callsubr\n48 hmoveto\n-93 callsubr\n12 hmoveto\n62 callsubr\n-99 callsubr\n-71 callsubr\n-103 callsubr\n-336 -12 rmoveto\n-99 callsubr\n60 hmoveto\n-96 callsubr\n-75 callsubr\n24 hmoveto\n-76 callsubr\n-92 callsubr\n-348 -12 rmoveto\n-76 callsubr\n60 hmoveto\n62 callsubr\n-30 callsubr\n-76 callsubr\n-98 callsubr\n24 hmoveto\n-94 callsubr\n-101 callsubr\n-504 -12 rmoveto\n-53 callsubr\n39 callsubr\n-30 callsubr\n108 hmoveto\n62 callsubr\n-102 callsubr\n60 hmoveto\n39 callsubr\n-93 callsubr\n12 hmoveto\n39 callsubr\n-456 -12 rmoveto\n85 callsubr\n-76 callsubr\n-53 callsubr\n39 callsubr\n-30 callsubr\n-101 callsubr\n72 hmoveto\n62 callsubr\n60 hmoveto\n85 callsubr\n-97 callsubr\n-101 callsubr\n36 hmoveto\n39 callsubr\n-99 callsubr\n-480 -12 rmoveto\n62 callsubr\n-7 callsubr\n60 hmoveto\n41 callsubr\n-99 callsubr\n-75 callsubr\n12 hmoveto\n-99 callsubr\n60 hmoveto\n-101 callsubr\n48 hmoveto\n62 callsubr\n-102 callsubr\n36 hmoveto\n-98 callsubr\n-480 -12 rmoveto\n-76 callsubr\n144 hmoveto\n-76 callsubr\n-96 callsubr\n48 hmoveto\n-53 callsubr\n60 hmoveto\n-98 callsubr\n-102 callsubr\n24 hmoveto\n-30 callsubr\n-480 -12 rmoveto\n-52 callsubr\n-76 callsubr\n85 callsubr\n120 hmoveto\n85 callsubr\n-99 callsubr\n48 hmoveto\n16 callsubr\n72 hmoveto\n85 callsubr\n-103 callsubr\n36 hmoveto\n-103 callsubr\n-408 -12 rmoveto\n-101 callsubr\n12 hmoveto\n-76 callsubr\n-101 callsubr\n96 hmoveto\n16 callsubr\n36 hmoveto\n39 callsubr\n108 hmoveto\n-103 callsubr\n36 hmoveto\n-30 callsubr\n-384 -12 rmoveto\n86 callsubr\n144 hmoveto\n-30 callsubr\n108 hmoveto\n85 callsubr\n24 hmoveto\n39 callsubr\n-348 -12 rmoveto\n-102 callsubr\n12 hmoveto\n39 callsubr\n-30 callsubr\n-101 callsubr\n48 hmoveto\n-76 callsubr\n132 hmoveto\n-102 callsubr\n36 hmoveto\n-103 callsubr\n-324 -12 rmoveto\n62 callsubr\n-97 callsubr\n-101 callsubr\n12 hmoveto\n63 callsubr\n132 hmoveto\n-101 callsubr\n36 hmoveto\n-30 callsubr\n-300 -12 rmoveto\n85 callsubr\n-98 callsubr\n16 callsubr\n144 hmoveto\n-53 callsubr\n24 hmoveto\n-76 callsubr\n-264 -12 rmoveto\n85 callsubr\n168 hmoveto\n85 callsubr\n24 hmoveto\n62 callsubr\n-72 -12 rmoveto\n62 callsubr\n24 hmoveto\n85 callsubr\n-60 -12 rmoveto\n-7 callsubr\n24 hmoveto\n16 callsubr\n-72 -12 rmoveto\n-76 callsubr\n24 hmoveto\n16 callsubr\n-72 -12 rmoveto\n40 callsubr\n12 hmoveto\n85 callsubr\n-60 -12 rmoveto\n-99 callsubr\n12 hmoveto\n63 callsubr\n-72 -12 rmoveto\n40 callsubr\n12 hmoveto\n-76 callsubr\n-60 -12 rmoveto\n-30 callsubr\n12 hmoveto\n63 callsubr\n-72 -12 rmoveto\n39 callsubr\n24 hmoveto\n-76 callsubr\n-72 -12 rmoveto\n62 callsubr\n36 hmoveto\n85 callsubr\n-72 -12 rmoveto\n-102 callsubr\n24 hmoveto\n-76 callsubr\n-98 callsubr\n-102 callsubr\n-108 -12 rmoveto\n39 callsubr\n-93 callsubr\n-108 -12 rmoveto\n85 callsubr\n-94 callsubr\n-48 -12 rmoveto\n85 callsubr\n39 callsubr\n",
        "initialPosition": {
            "x": 40,
            "y": 8
        },
        "endPosition": {
            "x": 49,
            "y": 58
        }
    },
    "Run0034.coderelay.png": {
        "commands":
        "-101 callsubr\n-24 -12 rmoveto\n-99 callsubr\n39 callsubr\n-101 callsubr\n-84 -12 rmoveto\n62 callsubr\n-99 callsubr\n62 callsubr\n-99 callsubr\n-108 -12 rmoveto\n85 callsubr\n-99 callsubr\n24 hmoveto\n62 callsubr\n-103 callsubr\n-120 -12 rmoveto\n39 callsubr\n-30 callsubr\n48 hmoveto\n62 callsubr\n-144 -12 rmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n60 hmoveto\n-30 callsubr\n-180 -12 rmoveto\n62 callsubr\n-98 callsubr\n-102 callsubr\n72 hmoveto\n63 callsubr\n-192 -12 rmoveto\n39 callsubr\n-99 callsubr\n108 hmoveto\n-99 callsubr\n-180 -12 rmoveto\n-30 callsubr\n120 hmoveto\n39 callsubr\n-180 -12 rmoveto\n16 callsubr\n72 hmoveto\n-101 callsubr\n12 hmoveto\n-7 callsubr\n39 callsubr\n-101 callsubr\n-192 -12 rmoveto\n62 callsubr\n84 hmoveto\n-96 callsubr\n-101 callsubr\n-180 -12 rmoveto\n16 callsubr\n24 hmoveto\n-53 callsubr\n36 hmoveto\n-99 callsubr\n-102 callsubr\n-156 -12 rmoveto\n39 callsubr\n36 hmoveto\n-101 callsubr\n36 hmoveto\n40 callsubr\n-156 -12 rmoveto\n63 callsubr\n24 hmoveto\n-101 callsubr\n36 hmoveto\n62 callsubr\n-103 callsubr\n-144 -12 rmoveto\n-99 callsubr\n72 hmoveto\n62 callsubr\n-30 callsubr\n-156 -12 rmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n-101 callsubr\n24 hmoveto\n62 callsubr\n-7 callsubr\n-144 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-102 callsubr\n24 hmoveto\n40 callsubr\n-132 -12 rmoveto\n-103 callsubr\n36 hmoveto\n-76 callsubr\n12 hmoveto\n62 callsubr\n-103 callsubr\n-132 -12 rmoveto\n39 callsubr\n36 hmoveto\n-103 callsubr\n24 hmoveto\n-30 callsubr\n-132 -12 rmoveto\n39 callsubr\n-101 callsubr\n24 hmoveto\n39 callsubr\n12 hmoveto\n-99 callsubr\n-132 -12 rmoveto\n39 callsubr\n-103 callsubr\n36 hmoveto\n-102 callsubr\n24 hmoveto\n-103 callsubr\n-132 -12 rmoveto\n39 callsubr\n-30 callsubr\n36 hmoveto\n-103 callsubr\n12 hmoveto\n-102 callsubr\n-132 -12 rmoveto\n-97 callsubr\n48 hmoveto\n-103 callsubr\n12 hmoveto\n-30 callsubr\n-264 -12 rmoveto\n-102 callsubr\n96 hmoveto\n41 callsubr\n-96 callsubr\n16 callsubr\n-99 callsubr\n-102 callsubr\n-300 -12 rmoveto\n16 callsubr\n-99 callsubr\n16 callsubr\n60 hmoveto\n-98 callsubr\n-75 callsubr\n-98 callsubr\n12 hmoveto\n39 callsubr\n-98 callsubr\n-312 -12 rmoveto\n40 callsubr\n85 callsubr\n-99 callsubr\n40 callsubr\n12 hmoveto\n-96 callsubr\n-74 callsubr\n12 hmoveto\n-95 callsubr\n-312 -12 rmoveto\n40 callsubr\n-101 callsubr\n36 hmoveto\n-99 callsubr\n24 hmoveto\n39 callsubr\n-96 callsubr\n-102 callsubr\n12 hmoveto\n-76 callsubr\n-95 callsubr\n-102 callsubr\n-336 -12 rmoveto\n62 callsubr\n-30 callsubr\n24 hmoveto\n62 callsubr\n-102 callsubr\n36 hmoveto\n-53 callsubr\n12 hmoveto\n62 callsubr\n24 hmoveto\n-73 callsubr\n-95 callsubr\n-101 callsubr\n-348 -12 rmoveto\n39 callsubr\n-103 callsubr\n24 hmoveto\n-98 callsubr\n-102 callsubr\n60 hmoveto\n-103 callsubr\n24 hmoveto\n-95 callsubr\n-76 callsubr\n-97 callsubr\n-336 -12 rmoveto\n40 callsubr\n24 hmoveto\n62 callsubr\n-29 callsubr\n-101 callsubr\n24 hmoveto\n-103 callsubr\n24 hmoveto\n-103 callsubr\n12 hmoveto\n39 callsubr\n-94 callsubr\n-102 callsubr\n-324 -12 rmoveto\n40 callsubr\n36 hmoveto\n62 callsubr\n-7 callsubr\n24 hmoveto\n-97 callsubr\n48 hmoveto\n-95 callsubr\n-300 -12 rmoveto\n62 callsubr\n-102 callsubr\n36 hmoveto\n-76 callsubr\n36 hmoveto\n-102 callsubr\n12 hmoveto\n16 callsubr\n48 hmoveto\n62 callsubr\n12 hmoveto\n39 callsubr\n-101 callsubr\n-288 -12 rmoveto\n62 callsubr\n120 hmoveto\n-53 callsubr\n16 callsubr\n24 hmoveto\n63 callsubr\n-240 -12 rmoveto\n-99 callsubr\n108 hmoveto\n-102 callsubr\n12 hmoveto\n86 callsubr\n24 hmoveto\n-99 callsubr\n-240 -12 rmoveto\n40 callsubr\n96 hmoveto\n-102 callsubr\n24 hmoveto\n62 callsubr\n24 hmoveto\n39 callsubr\n-228 -12 rmoveto\n63 callsubr\n84 hmoveto\n-101 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n85 callsubr\n-216 -12 rmoveto\n39 callsubr\n84 hmoveto\n-103 callsubr\n36 hmoveto\n-101 callsubr\n24 hmoveto\n62 callsubr\n-204 -12 rmoveto\n62 callsubr\n-99 callsubr\n-102 callsubr\n24 hmoveto\n-30 callsubr\n36 hmoveto\n-102 callsubr\n24 hmoveto\n62 callsubr\n-192 -12 rmoveto\n62 callsubr\n-96 callsubr\n36 hmoveto\n62 callsubr\n24 hmoveto\n39 callsubr\n-156 -12 rmoveto\n-75 callsubr\n48 hmoveto\n39 callsubr\n24 hmoveto\n-99 callsubr\n-72 -12 rmoveto\n-30 callsubr\n24 hmoveto\n39 callsubr\n-72 -12 rmoveto\n-103 callsubr\n36 hmoveto\n39 callsubr\n-72 -12 rmoveto\n-102 callsubr\n36 hmoveto\n62 callsubr\n-72 -12 rmoveto\n39 callsubr\n-101 callsubr\n12 hmoveto\n62 callsubr\n-72 -12 rmoveto\n62 callsubr\n-102 callsubr\n24 hmoveto\n-103 callsubr\n-60 -12 rmoveto\n-99 callsubr\n24 hmoveto\n-103 callsubr\n-60 -12 rmoveto\n-76 callsubr\n24 hmoveto\n-102 callsubr\n-60 -12 rmoveto\n85 callsubr\n24 hmoveto\n-101 callsubr\n-48 -12 rmoveto\n-102 callsubr\n24 hmoveto\n-102 callsubr\n-48 -12 rmoveto\n-103 callsubr\n24 hmoveto\n-103 callsubr\n-60 -12 rmoveto\n62 callsubr\n24 hmoveto\n85 callsubr\n-72 -12 rmoveto\n-99 callsubr\n-102 callsubr\n12 hmoveto\n86 callsubr\n-84 -12 rmoveto\n-98 callsubr\n24 hmoveto\n39 callsubr\n-30 callsubr\n-101 callsubr\n-96 -12 rmoveto\n62 callsubr\n-30 callsubr\n39 callsubr\n-99 callsubr\n-72 -12 rmoveto\n39 callsubr\n-98 callsubr\n-102 callsubr\n-48 -12 rmoveto\n16 callsubr\n",
        "initialPosition": {
            "x": 41,
            "y": 7
        },
        "endPosition": {
            "x": 39,
            "y": 62
        }
    },
    "Run0035.coderelay.png": {
        "commands":
        "-103 callsubr\n-98 callsubr\n-60 -12 rmoveto\n39 callsubr\n-98 callsubr\n-102 callsubr\n-84 -12 rmoveto\n-99 callsubr\n-101 callsubr\n24 hmoveto\n40 callsubr\n-96 -12 rmoveto\n-30 callsubr\n48 hmoveto\n39 callsubr\n-144 -12 rmoveto\n62 callsubr\n-98 callsubr\n60 hmoveto\n-53 callsubr\n-168 -12 rmoveto\n-96 callsubr\n-102 callsubr\n72 hmoveto\n-102 callsubr\n-168 -12 rmoveto\n39 callsubr\n-7 callsubr\n96 hmoveto\n16 callsubr\n-168 -12 rmoveto\n-99 callsubr\n108 hmoveto\n62 callsubr\n-168 -12 rmoveto\n-76 callsubr\n108 hmoveto\n40 callsubr\n-180 -12 rmoveto\n39 callsubr\n84 hmoveto\n39 callsubr\n-98 callsubr\n-168 -12 rmoveto\n16 callsubr\n60 hmoveto\n-101 callsubr\n12 hmoveto\n-97 callsubr\n-168 -12 rmoveto\n39 callsubr\n60 hmoveto\n39 callsubr\n62 callsubr\n-132 -12 rmoveto\n-30 callsubr\n36 hmoveto\n-76 callsubr\n-97 callsubr\n-144 -12 rmoveto\n-76 callsubr\n36 hmoveto\n-99 callsubr\n-102 callsubr\n12 hmoveto\n40 callsubr\n-156 -12 rmoveto\n63 callsubr\n24 hmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-103 callsubr\n-264 -12 rmoveto\n62 callsubr\n-30 callsubr\n72 hmoveto\n-99 callsubr\n24 hmoveto\n-30 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-103 callsubr\n-264 -12 rmoveto\n62 callsubr\n-97 callsubr\n48 hmoveto\n40 callsubr\n12 hmoveto\n-76 callsubr\n-101 callsubr\n12 hmoveto\n39 callsubr\n-101 callsubr\n-252 -12 rmoveto\n-94 callsubr\n36 hmoveto\n16 callsubr\n12 hmoveto\n-99 callsubr\n-101 callsubr\n12 hmoveto\n62 callsubr\n-103 callsubr\n-240 -12 rmoveto\n-97 callsubr\n39 callsubr\n-99 callsubr\n24 hmoveto\n-102 callsubr\n12 hmoveto\n62 callsubr\n-103 callsubr\n24 hmoveto\n-99 callsubr\n-101 callsubr\n-228 -12 rmoveto\n39 callsubr\n-99 callsubr\n-76 callsubr\n-99 callsubr\n16 callsubr\n12 hmoveto\n-30 callsubr\n24 hmoveto\n-99 callsubr\n-101 callsubr\n-204 -12 rmoveto\n62 callsubr\n-99 callsubr\n-76 callsubr\n-99 callsubr\n24 hmoveto\n-103 callsubr\n24 hmoveto\n62 callsubr\n-102 callsubr\n-168 -12 rmoveto\n-98 callsubr\n-76 callsubr\n24 hmoveto\n-103 callsubr\n36 hmoveto\n-99 callsubr\n-102 callsubr\n-144 -12 rmoveto\n-99 callsubr\n36 hmoveto\n-98 callsubr\n62 callsubr\n-7 callsubr\n-144 -12 rmoveto\n-7 callsubr\n24 hmoveto\n-76 callsubr\n-98 callsubr\n-76 callsubr\n-101 callsubr\n-204 -12 rmoveto\n62 callsubr\n-97 callsubr\n24 hmoveto\n-99 callsubr\n-76 callsubr\n-96 callsubr\n-228 -12 rmoveto\n-91 callsubr\n12 hmoveto\n-98 callsubr\n-76 callsubr\n-98 callsubr\n-102 callsubr\n-240 -12 rmoveto\n-98 callsubr\n-75 callsubr\n-97 callsubr\n16 callsubr\n-98 callsubr\n-75 callsubr\n-99 callsubr\n-240 -12 rmoveto\n-96 callsubr\n-102 callsubr\n24 hmoveto\n39 callsubr\n-99 callsubr\n62 callsubr\n-98 callsubr\n39 callsubr\n-103 callsubr\n-216 -12 rmoveto\n85 callsubr\n-98 callsubr\n36 hmoveto\n39 callsubr\n-92 callsubr\n-192 -12 rmoveto\n39 callsubr\n-99 callsubr\n24 hmoveto\n62 callsubr\n-98 callsubr\n39 callsubr\n-101 callsubr\n12 hmoveto\n-7 callsubr\n-192 -12 rmoveto\n62 callsubr\n-30 callsubr\n36 hmoveto\n-98 callsubr\n48 hmoveto\n-99 callsubr\n-180 -12 rmoveto\n39 callsubr\n-99 callsubr\n-101 callsubr\n24 hmoveto\n39 callsubr\n48 hmoveto\n39 callsubr\n-101 callsubr\n-180 -12 rmoveto\n-97 callsubr\n108 hmoveto\n-30 callsubr\n-168 -12 rmoveto\n39 callsubr\n-30 callsubr\n96 hmoveto\n-99 callsubr\n-156 -12 rmoveto\n85 callsubr\n-99 callsubr\n84 hmoveto\n39 callsubr\n-132 -12 rmoveto\n62 callsubr\n-30 callsubr\n60 hmoveto\n-99 callsubr\n-120 -12 rmoveto\n-96 callsubr\n16 callsubr\n12 hmoveto\n-99 callsubr\n-120 -12 rmoveto\n41 callsubr\n-96 callsubr\n-102 callsubr\n-108 -12 rmoveto\n-102 callsubr\n36 hmoveto\n-99 callsubr\n-101 callsubr\n-84 -12 rmoveto\n-103 callsubr\n36 hmoveto\n-7 callsubr\n-84 -12 rmoveto\n39 callsubr\n24 hmoveto\n-99 callsubr\n-101 callsubr\n-84 -12 rmoveto\n-30 callsubr\n24 hmoveto\n-99 callsubr\n-72 -12 rmoveto\n-30 callsubr\n24 hmoveto\n-30 callsubr\n-84 -12 rmoveto\n39 callsubr\n24 hmoveto\n39 callsubr\n-101 callsubr\n-84 -12 rmoveto\n-99 callsubr\n24 hmoveto\n-99 callsubr\n-72 -12 rmoveto\n-30 callsubr\n24 hmoveto\n-30 callsubr\n-72 -12 rmoveto\n-7 callsubr\n12 hmoveto\n39 callsubr\n-60 -12 rmoveto\n-103 callsubr\n24 hmoveto\n-99 callsubr\n-72 -12 rmoveto\n62 callsubr\n24 hmoveto\n-30 callsubr\n-72 -12 rmoveto\n85 callsubr\n24 hmoveto\n-7 callsubr\n-72 -12 rmoveto\n39 callsubr\n24 hmoveto\n-99 callsubr\n-101 callsubr\n-84 -12 rmoveto\n-76 callsubr\n24 hmoveto\n-98 callsubr\n-101 callsubr\n-96 -12 rmoveto\n-7 callsubr\n-101 callsubr\n24 hmoveto\n-98 callsubr\n-96 -12 rmoveto\n-76 callsubr\n-98 callsubr\n-76 callsubr\n-99 callsubr\n-72 -12 rmoveto\n85 callsubr\n-97 callsubr\n-102 callsubr\n-36 -12 rmoveto\n-98 callsubr\n",
        "initialPosition": {
            "x": 40,
            "y": 8
        },
        "endPosition": {
            "x": 34,
            "y": 63
        }
    }
}  # type: dict[str, bpy.CharStringWithoutInitialPosition]
